/************************/
/*   FolderDialog.cpp   */
/************************/
#include "stdafx.h"
#include "FolderDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CFolderDialog::CFolderDialog(LPCTSTR lpszFolderName,CWnd* pParent)
{
	m_folder   = lpszFolderName;
	if (pParent)
	{
		m_hwnd = pParent->m_hWnd;
	}
	else
	{
		m_hwnd = NULL;
	}
}

int CFolderDialog::DoModal()
{
	int				kotae;
	BROWSEINFO		bi;
	LPSTR			lpBuffer;
	LPITEMIDLIST	pidlRootFolders;
	LPITEMIDLIST	pidlBrowse;
	LPITEMIDLIST	pidlDefault;
	IMalloc			*g_pMalloc;

	kotae       = IDCANCEL;
	SHGetMalloc(&g_pMalloc);

	if((lpBuffer=(LPSTR)g_pMalloc->Alloc(MAX_PATH)) == NULL)return kotae;

	if (!SUCCEEDED(SHGetSpecialFolderLocation(m_hwnd,CSIDL_DESKTOP,&pidlRootFolders)))
	{
		g_pMalloc->Free(lpBuffer);
		return kotae;
	}

	pidlDefault = GetItemIDList(m_folder);

	// \
	bi.hwndOwner      = m_hwnd;
	bi.pidlRoot       = pidlRootFolders;
	bi.pszDisplayName = lpBuffer;
	bi.lpszTitle      = _T("fBNgF");
	bi.ulFlags        = 0;
	bi.lpfn           = (BFFCALLBACK)BrowseCallbackProc;
	bi.lParam         = (LPARAM)pidlDefault;

	pidlBrowse        = SHBrowseForFolder(&bi);

	// 擾
	if (pidlBrowse)
	{
		if (SHGetPathFromIDList(pidlBrowse,lpBuffer))
		{
			m_folder = lpBuffer;
			kotae    = IDOK;
		}
		g_pMalloc->Free(pidlBrowse);
	}

	// 
	g_pMalloc->Free(pidlRootFolders);
	g_pMalloc->Free(lpBuffer);
	g_pMalloc->Free(pidlDefault);

	return kotae;
}

LPITEMIDLIST CFolderDialog::GetItemIDList(CString p_cFileStr)
{
	LPITEMIDLIST	pIDL;
	LPSHELLFOLDER	pDesktopFolder; 
	ULONG			chEaten;
	ULONG			dwAttributes;
	HRESULT			hRes;
	OLECHAR			ochPath[_MAX_PATH];

	if( p_cFileStr.IsEmpty())return NULL;

	if( ::SHGetDesktopFolder( &pDesktopFolder ) != NOERROR)return NULL;

	::MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, p_cFileStr, -1, ochPath, MAX_PATH );

	hRes = pDesktopFolder->ParseDisplayName( NULL, NULL, ochPath, &chEaten, &pIDL, &dwAttributes);
	
	if( hRes != NOERROR)pIDL = NULL;
	
	pDesktopFolder->Release();

	return pIDL;
}

int AFXAPI CFolderDialog::BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	char chText[MAX_PATH];

	if( uMsg == BFFM_INITIALIZED )	
	{
		::SetWindowText(hwnd,_T("fBNg̑I"));
		::SendMessage(hwnd,BFFM_SETSELECTION,FALSE,lpData);
	}
	else
	{
		if(::SHGetPathFromIDList((LPITEMIDLIST)lParam,chText))
		::SendMessage(hwnd,BFFM_SETSTATUSTEXT,TRUE,(LPARAM)chText);
	}

	return 0;
}

CString	CFolderDialog::GetFolderName()
{
	return m_folder;
}
