/************************/
/*    KensakuDlg.cpp    */
/************************/
#include "stdafx.h"
#include "Oki.h"
#include "KensakuDlg.h"
#include "sente.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

extern char Current_Dir[];
extern char	hkyokumen[];

typedef struct
{
    char    sman[12];                   /* ΋ǎ */
    short   kyoku;                      /*          */
    char    gman[12];                   /* ΋ǎ */
	short	teai;						/* 荇     */
    short   nen;                        /* N         */
    short	tsuki;                      /*          */
    short	hi;                         /*          */
    short	kachi;                      /* s@@@ */
	short	kisen;						/* 햼     */
    short	senkei;                     /* ^       */
}IDX_S;

typedef struct
{
    int		kensu;                      /* o^   */
    int		yobi[9];
}DIR_S;

/////////////////////////////////////////////////////////////////////////////
// CKensakuDlg _CAO

IMPLEMENT_DYNAMIC(CKensakuDlg, CDialog)

CKensakuDlg::CKensakuDlg(char kisen_moji[][18],char senkei_moji[][18],
						 CWnd* pParent /*=NULL*/)
	: CDialog(CKensakuDlg::IDD, pParent)
{
	m_kishi1   = _T("");
	m_kishi2   = _T("");
	m_kyokumen = 0;
	m_kisen = _T("");
	m_senkei = _T("");
	m_snen = _T("");
	m_stsuki = _T("");
	m_enen = _T("");
	m_etsuki = _T("");

	get_kisen (kisen_moji);
	get_senkei(senkei_moji);
}

void CKensakuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_CBString(pDX, IDC_CMB_KISHI1, m_kishi1);
	DDX_CBString(pDX, IDC_CMB_KISHI2, m_kishi2);
	DDX_CBIndex(pDX, IDC_CMB_KYOKUMEN, m_kyokumen);
	DDX_CBString(pDX, IDC_CMB_KISEN, m_kisen);
	DDX_CBString(pDX, IDC_CMB_SENKEI, m_senkei);
	DDX_Text(pDX, IDC_EDIT_SNEN, m_snen);
	DDX_Text(pDX, IDC_EDIT_STSUKI, m_stsuki);
	DDX_Text(pDX, IDC_EDIT_ENEN, m_enen);
	DDX_Text(pDX, IDC_EDIT_ETSUKI, m_etsuki);
}

BEGIN_MESSAGE_MAP(CKensakuDlg, CDialog)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKensakuDlg bZ[W nh

/**************/
/* 햼擾 */
/**************/
void CKensakuDlg::get_kisen(char kisen_moji[][18])
{
    FILE    *fp;
    int     i;
	int		max;
    char    moji[80];
	char	filename[_MAX_PATH];

	sprintf_s(filename,"%s\\.DAT",Current_Dir);
	max = 99;
    for (i = 0 ; i <= max ; i++)
    {
        kisen_moji[i][0] = 0;
    }
	fopen_s(&fp,filename,"r");
    if (fp == NULL)return;
    while(fgets(moji,sizeof(moji),fp))
    {
		if (moji[0] == '+')continue;
        i = atoi(moji);
        if (i <= 0)continue;
        if (i > max)continue;
        last_space_cut(&moji[3]);
        get_moji(&kisen_moji[i][0],&moji[3],16);
    }
    fclose(fp);
}

/**************/
/* ^擾 */
/**************/
void CKensakuDlg::get_senkei(char senkei_moji[][18])
{
	int		i;
	int		max;
	char	moji[80];
	char	filename[_MAX_PATH];
	FILE	*fp;

	sprintf_s(filename,"%s\\^.DAT",Current_Dir);
	max = 99;

	for (i = 0 ; i <= max ; i++)
	{
		senkei_moji[i][0] = 0;
	}
	fopen_s(&fp,filename,"r");
    if (fp == NULL)return;
    while(fgets(moji,sizeof(moji),fp))
    {
		i = atoi(moji);
		if (i < 0)continue;
		if (i > max)continue;
		last_space_cut(&moji[4]);
		get_moji(&senkei_moji[i][0],&moji[4],16);
	}
	fclose(fp);
}

/********************************/
/* Ō̃Xy[XJbgB */
/********************************/
int CKensakuDlg::last_space_cut(char *s)
{
    int     i;
    int     llen;

    i = llen = 0;

    while(s[i])
    {
        if(s[i] == ' ')
        {
            i++;
        }
        else if(s[i] == '\n')
        {
            break;
        }
        else if (strncmp(&s[i],"@",2) == 0)
        {
            i += 2;
        }
        else if (moji_size((unsigned char)s[i]) == 2)
        {
            i   += 2;
            llen = i;
        }
        else
        {
            i++;
            llen = i;
        }

    }
    s[llen] = 0;
    return(llen);
}

/**************/
/* 擾 */
/**************/
void CKensakuDlg::get_moji(char *s2,char *s1,int max)
{
    int    len;
    int    iend;

    len  = 0;
    iend = 1;

    while(iend)
    {
        switch(moji_size(*s1))
        {
        case 1:
            if (len >= max)
            {
                iend = 0;
                break;
            }
            *s2++ = *s1++;
            len++;
            break;
        case 2:
            if ((len + 1) >= max)
            {
                iend = 0;
                break;
            }
            *s2++ = *s1++;
            *s2++ = *s1++;
            len += 2;
            break;
        default:
            iend = 0;
            break;
        }
    }
    *s2 = 0;
}

int CKensakuDlg::moji_size(char c1)
{
	unsigned char	c;

	c = (unsigned char)c1;
    if (c < 0x0020)return(0);
    if (c < 0x007f)return(1);
    if (c < 0x0081)return(0);
    if (c < 0x00a0)return(2);
    if (c < 0x00a1)return(0);
    if (c < 0x00e0)return(1);
    if (c < 0x00fd)return(2);
    return(0);
}

BOOL CKensakuDlg::OnInitDialog() 
{
	int			ip;
	char		filename[_MAX_PATH];
	char		moji[100];
	FILE		*fp;
	CComboBox	*pCB_Kishi1;
	CComboBox	*pCB_Kishi2;
	CComboBox	*pCB_Kisen;
	CComboBox	*pCB_Senkei;

	pCB_Kishi1 = (CComboBox*)GetDlgItem(IDC_CMB_KISHI1);
	pCB_Kishi2 = (CComboBox*)GetDlgItem(IDC_CMB_KISHI2);
	pCB_Kisen  = (CComboBox*)GetDlgItem(IDC_CMB_KISEN);
	pCB_Senkei = (CComboBox*)GetDlgItem(IDC_CMB_SENKEI);

	sprintf_s(filename,"%s\\m.DAT",Current_Dir);
	fopen_s(&fp,filename,"r");
	ip = 0;

	pCB_Kishi1->InsertString(-1,"");
	pCB_Kishi2->InsertString(-1,"");

	if (fp)
	{
		while(fgets(moji,sizeof(moji),fp))
    	{
        	if (last_space_cut(&moji[ip]) > 0)
			{
				pCB_Kishi1->InsertString(-1,&moji[ip]);
				pCB_Kishi2->InsertString(-1,&moji[ip]);
			}
		}
		fclose(fp);
    }

	sprintf_s(filename,"%s\\.DAT",Current_Dir);
	fopen_s(&fp,filename,"r");

	pCB_Kisen->InsertString(-1,"");
	if (fp)
	{
		while(fgets(moji,sizeof(moji),fp))
    	{
			if (moji[0] == '+')continue;
        	if (last_space_cut(&moji[3]) > 0)
			{
				pCB_Kisen->InsertString(-1,&moji[3]);
			}
		}
		fclose(fp);
    }

	sprintf_s(filename,"%s\\^.DAT",Current_Dir);
	fopen_s(&fp,filename,"r");
	pCB_Senkei->InsertString(-1,"");
	if (fp)
	{
		while(fgets(moji,sizeof(moji),fp))
    	{
        	if (last_space_cut(&moji[4]) > 0)
			{
				pCB_Senkei->InsertString(-1,&moji[4]);
			}
		}
		fclose(fp);
    }
	return CDialog::OnInitDialog();
}

void CKensakuDlg::OnOK() 
{
	if (UpdateData(TRUE))
	{
		if (strlen(m_snen) == 0)
		{
			m_nsnen = 0;
			CDialog::OnOK();
			return;
		}

		if (check_numeric(m_snen,&m_nsnen))
		{
			if ((m_nsnen < 1) || (m_nsnen > 2099))
			{
				MessageBox("1`2099͈̔͂œ͂ĂB","JnN");
				return;
			}
		}
		else
		{
			MessageBox("͂ĂB","JnN");
			return;
		}

		if (check_numeric(m_stsuki,&m_nstsuki))
		{
			if ((m_nstsuki < 1) || (m_nstsuki > 12))
			{
				MessageBox("1`12͈̔͂œ͂ĂB","Jn");
				return;
			}
		}
		else
		{
			MessageBox("͂ĂB","Jn");
			return;
		}

		if (check_numeric(m_enen,&m_nenen))
		{
			if ((m_nenen < 1) || (m_nenen > 2099))
			{
				MessageBox("1`2099͈̔͂œ͂ĂB","IN");
				return;
			}
		}
		else
		{
			MessageBox("͂ĂB","IN");
			return;
		}

		if (check_numeric(m_etsuki,&m_netsuki))
		{
			if ((m_netsuki < 1) || (m_netsuki > 12))
			{
				MessageBox("1`12͈̔͂œ͂ĂB","I");
				return;
			}
		}
		else
		{
			MessageBox("͂ĂB","I");
			return;
		}

		if (m_nsnen > m_nenen)
		{
			MessageBox("͈͎w肪ԈĂ܂B","΋Ǔ");
			return;
		}
		else if (m_nsnen == m_nenen)
		{
			if (m_nstsuki > m_netsuki)
			{
				MessageBox("͈͎w肪ԈĂ܂B","΋Ǔ");
				return;
			}
		}
		CDialog::OnOK();
	}
	CDialog::OnOK();
}

BOOL CKensakuDlg::check_numeric(CString m,int *kotae)
{
	char	moji[8];
	int		i;
	char	*s;

	strcpy_s(moji,m);
	s = moji;
	if (*s == 0)return(FALSE);
	i = 0;
	while(*s)
	{
		i *= 10;
		switch(*s)
		{
		case '1':
			i++;
			break;
		case '2':
			i += 2;
			break;
		case '3':
			i += 3;
			break;
		case '4':
			i += 4;
			break;
		case '5':
			i += 5;
			break;
		case '6':
			i += 6;
			break;
		case '7':
			i += 7;
			break;
		case '8':
			i += 8;
			break;
		case '9':
			i += 9;
		case '0':
			break;
		default:
			return(FALSE);
		}
		s++;
	}
	*kotae = i;
	return(TRUE);
}

/**************************/
/* Xy[XJbgB */
/**************************/
void CKensakuDlg::space_cut(char *s2,char *s1)
{
    while(*s1)
    {
        if(*s1 == ' ')
        {
            s1++;
        }
        else if (strncmp(s1,"@",2) == 0)
        {
            s1 += 2;
        }
        else
        {
        	switch(moji_size((unsigned char)*s1))
			{
        	case 2:
            	*s2++ = *s1++;
			case 1:
            	*s2++ = *s1++;
				break;
			default:
				s1++;
				break;
			}
        }
    }
    *s2 = 0;
}

/****************/
/* ԍ擾 */
/****************/
int CKensakuDlg::get_kisen_no(CString s,char kisen_moji[][18],int max)
{
	char	moji[18];
	char	moji2[18];
	int		i;

	strcpy_s(moji,s);
	space_cut(moji,moji);
	if (moji[0] == 0)return(0);
	for (i = 0;i < max;i++)
	{
		space_cut(moji2,&kisen_moji[i][0]);
		if (strcmp(moji,moji2) == 0)return(i);
	}
	return(0);
}

/****************/
/* ^ԍ擾 */
/****************/
int CKensakuDlg::get_senkei_no(CString s,char senkei_moji[][18],int max)
{
	char	moji[18];
	char	moji2[18];
	int		i;

	strcpy_s(moji,s);
	space_cut(moji,moji);
	if (moji[0] == 0)return(0);
	for (i = 0;i < max;i++)
	{
		space_cut(moji2,&senkei_moji[i][0]);
		if (strcmp(moji,moji2) == 0)return(i);
	}
	return(0);
}

/*********************************************************************/
/*                                                                   */
/*           Rf[^@@@uPDOO@@@@@ @@       */
/*                                                                   */
/*           @\@@F@Rf[^x[XYf[^݂̂𒊏o    */
/*                                                                   */
/*                     B                                        */
/*                                                                   */
/*           쐬ҁ@F@{q(SAF53393 & GCA02313 & TORA0332)    */
/*                                                                   */
/*           쐬@F@OVNPQQU                      */
/*                                                                   */
/*-------------------------------------------------------------------*/
/*                                                                   */
/*           ύXPF@@@N@@@@                      */
/*                                                                   */
/*           ύX_PF@            @@@@@@@@                */
/*                                                                   */
/*********************************************************************/

int CKensakuDlg::kensaku2(char *shiro_name,char *sman,char *gman,
						int	kisen_no,int senkei_no,int snen,int stsuki,int enen,int etsuki,
						int kensaku_prog,char *s_men)
{
    int				teban;
    int				koma;
    int				kotae;
	int				h_cnt;
    int				no;
    int				i;
    int				ichi_new;
    int				ichi_old;
    int				max;
	int				idx_flag;
	int				teban_flag;
    int             idx_buf[20];
	char			men[100];
	char			ssman[28];
	char			ggman[28];
	char			filename[_MAX_PATH];
	unsigned char   kifu[256][2];
	IDX_S		    idx;
    DIR_S		    *dir;
    FILE			*fpi;
    FILE			*fpk;
    FILE			*fp;

	/*  tO쐬  */
	space_cut(ssman,sman);
	space_cut(ggman,gman);
    idx_flag  = ((int)ssman[0]) | ((int)ggman[0]) | kisen_no | senkei_no | snen;

	/* CfbNXt@CI[v */
    sprintf_s(filename,"%s.MIX",shiro_name);
    fopen_s(&fpi,filename,"rb");
    if (fpi == 0)return(0);
    fread (idx_buf,1,40,fpi);
    dir = (DIR_S *)idx_buf;
    max = dir->kensu;

	/* f[^t@CI[v */
    sprintf_s(filename,"%s.MKF",shiro_name);
    fopen_s(&fpk,filename,"rb");
    if (fpk == 0)
    {
        fclose(fpi);
        return(0);
    }

	/* ʊi[t@C쐬 */
	sprintf_s(filename,"%s\\.DAT",Current_Dir);
    fopen_s(&fp,filename,"wb");
    if ((idx_flag == 0) && (kensaku_prog == 0))
    {
        for (no = 1 ; no <= max ; no++)
        {
            fwrite(&no,1,4,fp);
        }
        h_cnt = max;
    }
    else
    {
        h_cnt = 0;
        for(no = 1 ; no <= max ; no++)
        {
            if (kensaku_prog)
            {
                fread (kifu,2,256,fpk);
				idx.teai = 0;
				if (kifu[0][0] == 255)
				{
					idx.teai = kifu[0][1];
				}
            }
            if (idx_flag)
            {
                fread (idx.sman,1,40,fpi);
				if(check_name(ssman,idx.sman,idx.gman))continue;
				if(check_name(ggman,idx.sman,idx.gman))continue;
				if (kisen_no != 0)
                {
                    if (kisen_no != idx.kisen)continue;
                }

                if (senkei_no != 0)
                {
                    if (senkei_no != idx.senkei)continue;
                }

                if (snen != 0)
                {
                    if (idx.nen < snen)
                    {
                        continue;
                    }
                    else if (idx.nen == snen)
                    {
                        if (idx.tsuki < stsuki)
                        {
                            continue;
                        }
                    }

                    if (idx.nen > enen)
                    {
                        continue;
                    }
                    else if (idx.nen == enen)
                    {
                        if (idx.tsuki > etsuki)
                        {
                            continue;
                        }
                    }
                }
            }

            if (kensaku_prog == 0)
            {
                kotae = 3;
            }
            else
            {
                kotae = 0;
    			memcpy(men,hkyokumen,100);
				switch (idx.teai)
				{
				case 0:					// 
					teban_flag = 0;
					break;
				case 1:					// 
					K11 = 0;
					teban_flag = 1;
					break;
				case 2:					// p
					K22 = 0;
					teban_flag = 1;
					break;
				case 3:					// 򗎂
					K82 = 0;
					teban_flag = 1;
					break;
				case 4:					// 򍁗
					K11 = K82 = 0;
					teban_flag = 1;
					break;
				case 5:					// 񖇗
					K22 = K82 = 0;
					teban_flag = 1;
					break;
				case 6:					// l
					K11 = K91 = K22 = K82 = 0;
					teban_flag = 1;
					break;
				case 7:					// Z
					K11 = K21 = K81 = K91 = K22 = K82 = 0;
					teban_flag = 1;
					break;
				case 8:					// 
					K11 = K21 = K31 = K71 = K81 = K91 = K22 = K82 = 0;
					teban_flag = 1;
					break;
				case 9:					// \
					K11 = K21 = K31 = K41 = K61 = K71 = K81 = K91 = K22 = K82 = 0;
					teban_flag = 1;
					break;
				default:				// 
					K11 = K21 = K31 = K41 = K61 = K71 = K81 = K91 = K22 = K82 = 0;
					for (i = 19 ; i <= 27 ; i++)
					{
						men[i] = 0;
					}
					teban_flag = 1;
					break;
				}

                /* ۂɊȂׂĂ݂B */
                for (i = teban_flag ; i < 256 ; i++)
                {
                    if (kensaku_prog == 3)  /* ǖʌ */
                    {
                        if (memcmp(men,s_men,82) == 0)
                        {
                            kotae = 2;
                            break;
                        }
                    }
                    else                    /* ގǖʌ */
                    {
                        if (banmen_check(s_men,men,kensaku_prog) == 0)
                        {
                            kotae = 1;
                            break;
                        }
                    }
                    teban = i & 0x0001;
                    ichi_new = kifu[i][0] & 0x7f;
                    if (ichi_new == 0)break;
                    ichi_old = kifu[i][1];
                    if (ichi_old <= 100)
                    {
                        koma = men[ichi_old];
                        men[ichi_old] = 0;
                        if (kifu[i][0] > 100)
                        {
                            if (koma > 0)
                            {
                                koma |= 0x08;
                            }
                            else if (koma > -8)
                            {
                                koma -= 8;
                            }
                        }
						men[ichi_new] = koma;
                    }
                    else
                    {
                        koma = ichi_old & 0x07;
						if (teban == 1)
                        {
                        	koma = -koma;
						}
						men[ichi_new] = koma;
                    }
                }
            }
            if (kotae)
            {
                fwrite(&no,1,4,fp);
                h_cnt++;
            }
        }
    }
    fclose(fpi);
    fclose(fpk);
    fclose(fp);
    return(h_cnt);
}

/**********************/
/* m𒲍B */
/**********************/
BOOL CKensakuDlg::check_name(char* name,char* sman,char* gman)
{
	char	man[14];
	char	moji[14];

	if (name[0] == 0)return(FALSE);				// `FbNΏۊO ---> i

	memcpy(man,sman,12);
	man[12] = 0;
	space_cut(moji,man);
	if (strcmp(name,moji) == 0)return(FALSE);	// v  ----> i

	memcpy(man,gman,12);
	space_cut(moji,man);
	if (strcmp(name,moji) == 0)return(FALSE);	// v  ----> i
	return(TRUE);
}

/********************************************/
/* Ֆʂ{Ăǖʂƈv邩ׂB */
/********************************************/
int CKensakuDlg::banmen_check(char *p,char *k,int kensaku_prog)
{
    int i;
    int kotae;

    kotae = 0;
    for (i = 1 ; i <= 81; i++)
    {
        if(p[i] == 0)continue;
        if(p[i] != k[i])
        {
            kotae = 1;
            break;
        }
    }
    if (kotae == 0)return(0);

	if (kensaku_prog == 2)return(-1);

    for (i = 1 ; i <= 81; i++)
    {
        if(p[i] == 0)continue;
        if(p[i] != (-k[82 - i]))
        {
            return(-1);
        }
    }
    return(0);
}
