/************************/
/*     LoginDlg.cpp     */
/************************/
#include "stdafx.h"
#include "Oki.h"
#include "LoginDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CLoginDlg _CAO

IMPLEMENT_DYNAMIC(CLoginDlg, CDialog)

CLoginDlg::CLoginDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoginDlg::IDD, pParent)
{
	CWinApp		*pApp;

	MySection2 = _T("Settings");
	pApp       = AfxGetApp();
	m_server = pApp->GetProfileString(MySection2,_T("SERVER"),_T("gserver.computer-shogi.org"));
	m_port   = pApp->GetProfileInt(MySection2,_T("PORT"),4081);
	m_user   = pApp->GetProfileString(MySection2,_T("USER"));
	m_pass   = pApp->GetProfileString(MySection2,_T("PASSWORD"));
}

void CLoginDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_EDIT_SERVER, m_server);
	DDV_MaxChars(pDX, m_server, 31);
	DDX_Text(pDX, IDC_EDIT_PORT, m_port);
	DDV_MinMaxInt(pDX, m_port, 1024, 32767);
	DDX_Text(pDX, IDC_EDIT_PASSWORD, m_pass);
	DDV_MaxChars(pDX, m_pass, 31);
	DDX_Text(pDX, IDC_EDIT_USER, m_user);
	DDV_MaxChars(pDX, m_user, 15);
}

BEGIN_MESSAGE_MAP(CLoginDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_DEFAULT, OnButtonDefault)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoginDlg bZ[W nh

void CLoginDlg::OnButtonDefault() 
{
	if (!UpdateData(TRUE))return;

	m_server = _T("gserver.computer-shogi.org");
	m_port   = 4081;
	UpdateData(FALSE);
}

void CLoginDlg::OnOK() 
{
	if (!UpdateData(TRUE))return;

	CWinApp		*pApp;

	pApp       = AfxGetApp();
	pApp->WriteProfileString(MySection2,_T("SERVER"),m_server);
	pApp->WriteProfileInt(MySection2,_T("PORT"),m_port);
	pApp->WriteProfileString(MySection2,_T("USER"),m_user);
	pApp->WriteProfileString(MySection2,_T("PASSWORD"),m_pass);

	CDialog::OnOK();
}
