/************************/
/*      OkiDoc.cpp      */
/************************/
#include "stdafx.h"
#include "Oki.h"
#include "OkiDoc.h"
#include <time.h>
#include <math.h>
#include "sente.h"

extern void strcopy(char *s1,char *s2);
extern void strcat2(char *s1,char *s2);

extern int	clip_open();
extern int	clip_gets(char *buf,int len);
extern void clip_close(void);
extern void clip_offset(int offset);

extern int	utf2sjis(char *moji,char *sjis);

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// COkiDoc

IMPLEMENT_DYNCREATE(COkiDoc, CDocument)

BEGIN_MESSAGE_MAP(COkiDoc, CDocument)
	ON_COMMAND(ID_FILE_CLIP_IN, &COkiDoc::OnFileClipIn)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLIP_IN, &COkiDoc::OnUpdateFileClipIn)
END_MESSAGE_MAP()

extern int				job_no;
extern int				tesu;
extern int				teban_flag;
extern int				end_code;
extern int				i_man[];
extern int				timer_sec[];
extern int				shohi[];
extern char				initial_kyokumen[];
extern char				hkyokumen[];
extern unsigned char	kifu[][2];
extern char				men_h[];
extern char				sman[];
extern char				gman[];
extern char				sman2[];
extern char				gman2[];

static char	*sansuji[]  = { "P","Q","R","S","T","U","V","W","X"};
static char	*kansuji[]  = { "","","O","l","","Z","","",""};
static char *xmoji = "PQRSTUVWX";
static char *ymoji = "OlܘZ\";
static char *kakinoki_koma = "Ejpʂƈǌ\Sn";
static char *csa_koma      = "  FUKYKEGIKIKAHIOUTONYNKNG  UMRY";
static char *nari = "";
static char *komamoji[] = { "@","",""  ,"j"  ,""  ,"","p",""
						   ,"","","","j","","","n",""};
static char *teai_moji[] = { "@@" , "@" , "p@" ,
                             "ԗ" , "򍁗" , "񖇗" ,
                             "l" , "Z" , "̑@" };
static int	teai_len[] = { 4 , 6 , 6 , 8 , 8 , 8 , 8 , 8 , 6 };

// COkiDoc RXgNV/fXgNV

COkiDoc::COkiDoc()
{
	time_t	local;
	tm		today;

	time(&local);
	local += 32400;
	gmtime_s(&today,&local);
   	nen   = today.tm_year + 1900;
   	tsuki = today.tm_mon + 1;
   	hi    = today.tm_mday;

	crlf[0] = 0x0d;
	crlf[1] = 0x0a;
	crlf[2] = 0;
}

COkiDoc::~COkiDoc()
{
}

BOOL COkiDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)

	return TRUE;
}

// COkiDoc VA

void COkiDoc::Serialize(CArchive& ar)
{
	int		iexit;
	int		i;
	int		j;
	int		jj;
	int		k;
	int		v;
	int		len;
	int		old;
	int		newx;
	int		ix;
	int		iy;
	int		iprog;
	int		ip;
	int		te;
	int		teki;
	int		koma;
	int		naru;
	int		mochi_flag;
	int		maisu;
	int		sec;
	int		min;
	int		hour;
	int		men_i[10][10];
	int		mochi[2][8];
	char	men[100];
	char	ssman[28];
	char	ggman[28];
	char	moji[_MAX_PATH];
	char	sjis[_MAX_PATH];
	char	*s;
	char	*m;
	char	*y;
	char	*kmoji;

	if (ar.IsStoring())
	{
		if (i_man[0] >= 0)
		{
			strcopy(ssman,sman);
			if (i_man[0] == 10)
			{
				if (sman2[0])strcopy(ssman,sman2);
			}
		}
		else if (sman2[0])
		{
			strcopy(ssman,sman2);
		}
		else
		{
			strcopy(ssman,sman);
		}

		if (i_man[1] >= 0)
		{
			strcopy(ggman,gman);
			if (i_man[1] == 10)
			{
				if (gman2[0])strcopy(ggman,gman2);
			}
		}
		else if (gman2[0])
		{
			strcopy(ggman,gman2);
		}
		else
		{
			strcopy(ggman,gman);
		}

		switch(itype)
		{
		case 1:
			if (teban_flag)
			{
				sprintf_s(moji,"F%s%s",ssman,crlf);
				ar.WriteString(moji);
				sprintf_s(moji,"F%s%s",ggman,crlf);
				ar.WriteString(moji);
			}
			else
			{
				sprintf_s(moji,"F%s%s",ssman,crlf);
				ar.WriteString(moji);
				sprintf_s(moji,"F%s%s",ggman,crlf);
				ar.WriteString(moji);
			}
			sprintf_s(moji,"tF%d N %d  %d %s",nen,tsuki,hi,crlf);
			ar.WriteString(moji);
			if (teban_flag)
			{
				sprintf_s(moji,"ԁF%s",crlf);
			}
			else
			{
				sprintf_s(moji,"ԁF%s",crlf);
			}
			ar.WriteString(moji);

			/**************/
			/* ǖʐ} */
			/**************/
			memcpy(men,initial_kyokumen,100);
			for (i = 9 ; i <= 81 ; i += 9)
			{
				ar.WriteString("|");
				for (j = 0 ; j < 9; j++)
				{
					jj = i - j;
					if (men[jj] >= 0)
					{
						k = (int)men[jj] * 2;
						sprintf_s(moji," %c%c",kakinoki_koma[k],kakinoki_koma[k+1]);
					}
					else
					{
						k = (int)(-men[jj]) * 2;
						sprintf_s(moji,"v%c%c",kakinoki_koma[k],kakinoki_koma[k+1]);
					}
					ar.WriteString(moji);
				}
				ar.WriteString(crlf);
			}
			kmoji = kakinoki_koma + 2;

			ar.WriteString("莝F");
			for (i = 83 ; i < 90 ; i++)
			{
				j = men[i];
				if (j == 0)continue;
				k = (i - 83) * 2;
				sprintf_s(moji,"%c%c",kmoji[k],kmoji[k + 1]);
				ar.WriteString(moji);
				if (j == 1)continue;
				if (j <= 10)
				{
					k = (j - 1) * 2;
					sprintf_s(moji,"%c%c",ymoji[k],ymoji[k + 1]);
				}
				else
				{
					k = (j - 11) * 2;
					sprintf_s(moji,"\%c%c",ymoji[k],ymoji[k + 1]);
				}
				ar.WriteString(moji);
			}
			ar.WriteString(crlf);

			ar.WriteString("莝F");
			for (i = 91 ; i < 98 ; i++)
			{
				j = men[i];
				if (j == 0)continue;
				k = (i - 91) * 2;
				sprintf_s(moji,"%c%c",kmoji[k],kmoji[k + 1]);
				ar.WriteString(moji);
				if (j == 1)continue;
				if (j <= 10)
				{
					k = (j - 1) * 2;
					sprintf_s(moji,"%c%c",ymoji[k],ymoji[k + 1]);
				}
				else
				{
					k = (j - 11) * 2;
					sprintf_s(moji,"\%c%c",ymoji[k],ymoji[k + 1]);
				}
				ar.WriteString(moji);
			}
			ar.WriteString(crlf);
			ar.WriteString(crlf);

			/************/
			/* o */
			/************/
			te = teban_flag;
			while(kifu[te][0])
			{
				kifuout(te,moji);
				moji[16] = 0;
				ar.WriteString(moji);
				sec   = shohi[te];
				min   = sec / 60;
				sec  %= 60;
				hour  = min / 60;
				min  %= 60;
				sprintf_s(moji,"(%02d:%02d:%02d)%s",hour,min,sec,crlf);
				ar.WriteString(moji);
				te++;
		    }

			/******************/
			/* IR[ho */
			/******************/
			switch(end_code)
			{
			case 1:
				if ((te & 0x01) == 0)
				{
					sprintf_s(moji,"KINTE%s",crlf);
				}
				else
				{
					sprintf_s(moji,"MAKE%s",crlf);
				}
				break;
			case 2:
				if ((te & 0x01) == 0)
				{
					sprintf_s(moji,"MAKE%s",crlf);
				}
				else
				{
					sprintf_s(moji,"KINTE%s",crlf);
				}
				break;
			case 7:
				sprintf_s(moji,"*ȉ%s",crlf);
				ar.WriteString(moji);
			case 3:
				sprintf_s(moji,"SENNITITE%s",crlf);
				break;
			case 8:
				sprintf_s(moji,"*ȉ%s",crlf);
				ar.WriteString(moji);
			case 4:
				sprintf_s(moji,"JISHOUGI%s",crlf);
				break;
			case 5:
				sprintf_s(moji,"*ȉ菟%s",crlf);
				ar.WriteString(moji);
				sprintf_s(moji,"BREAK%s",crlf);
				break;
			case 6:
				sprintf_s(moji,"*ȉ菟%s",crlf);
				ar.WriteString(moji);
				sprintf_s(moji,"MAKE%s",crlf);
				break;
			default:
				sprintf_s(moji,"BREAK%s",crlf);
				break;
			}
			ar.WriteString(moji);
			break;
		case 2:
			message[0] = 0;
			for (i = 83 ; i < 98; i++)
			{
				if (initial_kyokumen[i])
				{
					strcopy(message,"݂̑ǖʂ́AZ[uo܂B");
					break;
				}
			}
			if (message[0])break;

			/******************/
			/* ΋ǎҏ */
			/******************/
			sprintf_s(moji,"N+%s",ssman);
			ar.WriteString(moji);
			ar.WriteString(crlf);
		    sprintf_s(moji,"N-%s",ggman);
			ar.WriteString(moji);
			ar.WriteString(crlf);

			/******************/
			/* ǖʐ} */
			/******************/
			memcpy(men,initial_kyokumen,84);
			for (i = 9 ; i <= 81 ; i += 9)
			{
				sprintf_s(moji,"P%d",i / 9);
				ar.WriteString(moji);
				for (j = 0 ; j < 9; j++)
				{
					jj = i - j;
					k  = men[jj];
					if (k == 0)
					{
						sprintf_s(moji," * ");
					}
					else
					{
						if (k > 0)
						{
							moji[0] = '+';
						}
						else
						{
							moji[0] = '-';
							k = -k;
							men[jj] = k;
						}
						k *= 2;
						moji[1] = csa_koma[k];
						moji[2] = csa_koma[k + 1];
						moji[3] = 0;
					}
					ar.WriteString(moji);
				}
				ar.WriteString(crlf);
			}

			/****************/
			/* ԏ */
			/****************/
			if (teban_flag)
			{
				ar.WriteString("-");
			}
			else
			{
				ar.WriteString("+");
			}
			ar.WriteString(crlf);

			/****************/
			/*  */
			/****************/
			te  = teban_flag;
			while(kifu[te][0])
			{
				if ((te & 0x0001))
				{
					moji[0] = '-';
				}
				else
				{
					moji[0] = '+';
				}
				old  = kifu[te][1];
				newx = kifu[te][0];
				if (old > UCHI_KOMA)
				{
					iy = (newx + 8) / 9;
					ix = newx - 9 * (iy - 1);
					sprintf_s(&moji[1],5,"00%d%d",ix,iy);
					k = old - UCHI_KOMA;
				}
				else
				{
					iy = (old + 8) / 9;
					ix = old - 9 * (iy - 1);
					sprintf_s(&moji[1],3,"%d%d",ix,iy);
					k = men[old];
					if (newx > NARU_CODE)
					{
						newx -= NARU_CODE;
						k    += 8;
					}
					iy = (newx + 8) / 9;
					ix = newx - 9 * (iy - 1);
					sprintf_s(&moji[3],3,"%d%d",ix,iy);
				}
				men[newx] = k;
				k *= 2;
				sprintf_s(&moji[5],3,"%c%c",csa_koma[k],csa_koma[k + 1]);
				ar.WriteString(moji);
				ar.WriteString(crlf);

				if ((te - 2) >= teban_flag)
				{
					sec = shohi[te] - shohi[te - 2];
				}
				else
				{
					sec = shohi[te];
				}
				sprintf_s(moji,"T%d",sec);
				ar.WriteString(moji);
				ar.WriteString(crlf);
				te++;
			}

			switch(end_code)
			{
			case 1:
			case 2:
				sprintf_s(moji,"%cTORYO",'%');
				break;
			default:
				sprintf_s(moji,"%cCHUDAN",'%');
			}
			ar.WriteString(moji);
			ar.WriteString(crlf);
			break;
		default:
			break;
		}
	}
	else if (job_no == 0)
	{
		iexit = 0;
		memset(men,0,100);
		ssman[0] = ggman[0] = 0;
		switch(itype)
		{
		case 1:
			iprog = -1;
			while(ar.ReadString(moji,sizeof(moji) - 1))
			{
				if (iprog < 0)
				{
					if (moji[0] == '#')
					{
						iprog = 13;
					}
					else
					{
						iprog = 0;
					}
				}
				switch(iprog)
				{
				case 0:
					if (strncmp(moji,"F",6) == 0)
					{
						get_moji(ssman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"F",6) == 0)
					{
						get_moji(ggman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"F",6) == 0)
					{
						get_moji(ssman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"F",6) == 0)
					{
						get_moji(ggman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"tF",6) == 0)
					{
						tab_cut (&moji[6]);
						get_date(&moji[6]);
						break;
					}
					else if (strncmp(moji,"ԁF",6) == 0)
					{
						if (strncmp(&moji[6],"",6) == 0)
						{
							tesu = teban_flag = 0;
						}
						else if (strncmp(&moji[6],"",6) == 0)
						{
							tesu = teban_flag = 1;
						}
						else if (strncmp(&moji[6],"",6) == 0)
						{
							tesu = teban_flag = 1;
						}
						else if (strncmp(&moji[6],"",6) == 0)
						{
							tesu = teban_flag = 0;
						}
						break;
					}
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:
				case 7:
				case 8:
					if (moji[0] == '|')	// `،`
					{
						iprog++;
						ip = iprog * 9;
						m  = moji + 1;
						for (i = 0 ; i < 9 ; i++)
						{
							switch(*m++)
							{
							case 'v':
							case 'V':
								teki = 1;
								break;
							default:
								teki = 0;
								break;
							}

							kmoji = kakinoki_koma;
							for (koma = 0 ; koma < 16; koma++)
							{
								if (strncmp(m,kmoji,2) == 0)break;
								kmoji += 2;
							}
							if (koma >= 16)
							{
								if (strncmp(m,"",2) == 0)
								{
									koma = SRYU;
								}
								else if (strncmp(m,"",2) == 0)
								{
									koma = SOU;
								}
								else
								{
									koma = 0;
								}
							}

							if (koma == SOU)
							{
								if (teki)
								{
									PGOU = ip;
								}
								else
								{
									PSOU = ip;
								}
							}
							if (teki)koma = -koma;
							men[ip--] = koma;
							m += 2;
						}
            		}
					break;
				case 9:
		            if ((strncmp(moji,"莝F",10) == 0) || 
				    	(strncmp(moji,"莝F",10) == 0)	)
					{
						iprog++;
						m = moji + 10;
						while(*m)
						{
							kmoji = kakinoki_koma + 2;
							koma  = 0;
							for (i = 1 ; i < 8 ; i++)
							{
								if (strncmp(m,kmoji,2) == 0)
								{
									koma = i;
									m += 2;
									if (strncmp(m,"\",2) == 0)
									{
										maisu = 10;
										m += 2;
									}
									else
									{
										maisu = 1;
									}
									y = ymoji;
									for (j = 1 ; j < 10 ; j++)
									{
										if (strncmp(m,y,2) == 0)
										{
											if (maisu > 9)
											{
												maisu += j;
											}
											else
											{
												maisu = j;
											}
											m += 2;
											break;
										}
										y += 2;
									}
									break;
								}
								kmoji += 2;
							}
							if (koma)
							{
								men[koma + 82] = maisu;
							}
							else
							{
								break;
							}
						}
					}
					break;
				case 10:
					if ((strncmp(moji,"莝F",10) == 0)	||
		            	(strncmp(moji,"莝F",10) == 0) )
					{
						iprog++;
						m = moji + 10;
						while(*m)
						{
							kmoji = kakinoki_koma + 2;
							koma  = 0;
							for (i = 1 ; i < 8 ; i++)
							{
								if (strncmp(m,kmoji,2) == 0)
								{
									koma = i;
									m += 2;
									if (strncmp(m,"\",2) == 0)
									{
										maisu = 10;
										m += 2;
									}
									else
									{
										maisu = 1;
									}
									y = ymoji;
									for (j = 1 ; j < 10 ; j++)
									{
										if (strncmp(m,y,2) == 0)
										{
											if (maisu > 9)
											{
												maisu += j;
											}
											else
											{
												maisu = j;
											}
											m += 2;
											break;
										}
										y += 2;
									}
									break;
								}
								kmoji += 2;
							}
							if (koma)
							{
								men[koma + 90] = maisu;
							}
							else
							{
								break;
							}
						}
						memcpy(initial_kyokumen,men,100);
						memcpy(men_h,men,100);
						te = teban_flag;
						kifu[te][0] = 0;
						sman2[0] = gman2[0] = 0;
						strcopy(sman,ssman);
						strcopy(gman,ggman);
						timer_sec[0] = timer_sec[1] = 0;
						i = 1;
						for (iy = 1;iy < 10 ; iy++)
						{
							for (ix = 1; ix < 10;ix++)
							{
								j = men[i++];
								if (j < 0)
								{
									j = -j + 16;
								}
								men_i[ix][iy] = j;
							}
						}
						for (j = 0; j < 8 ; j++)
						{
							mochi[0][j] = men[i++];
						}
						for (j = 0; j < 8 ; j++)
						{
							mochi[0][j] = men[i++];
						}
					}
					break;
				case 11:	// Xc
		            if (strncmp(moji,"MAKE",4) == 0)
					{
						if ((te & 0x01) == 0)
						{
							end_code = 2;
						}
						else
						{
							end_code = 1;
						}
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"BREAK",5) == 0)
					{
						end_code = 0;
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"KINTE",5) == 0)
					{
						if ((te & 0x01) == 0)
						{
							end_code = 1;
						}
						else
						{
							end_code = 2;
						}
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"SENNITITE",9) == 0)
					{
						end_code = 3;
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"JISHOUGI",8) == 0)
					{
						end_code = 4;
						iprog++;
						iexit = 1;
					}
					else if (tesu >= 3000)
					{
						end_code = 0;
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"",2) == 0)
					{
						kmove(0,&moji[2],men_i,mochi);
						touroku(te);
						shohi[te] = get_shohi(moji);
						te++;
					}
					else if (strncmp(moji,"",2) == 0)
					{
						kmove(1,&moji[2],men_i,mochi);
						touroku(te);
						shohi[te] = get_shohi(moji);
						te++;
					}
					break;
				case 12:
					break;
				case 13:	// `،`
					if (strncmp(moji,"JnF",10) == 0)
					{
						get_date(&moji[10]);
						iprog++;
						break;
					}
				case 14:
					if (strncmp(moji,"荇F",8) == 0)
					{
						for (i = 0 ; i < 9 ; i++)
						{
							if(strncmp(&moji[8],teai_moji[i],teai_len[i]) == 0)
							{
								switch (i)
								{
								case 0:         /*  */
									memcpy(men,hkyokumen,100);
									tesu = teban_flag = 0;
									iprog = 26;
									break;
								case 1:         /*  */
									memcpy(men,hkyokumen,100);
									K11 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 2:         /* p */
									memcpy(men,hkyokumen,100);
									K22 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 3:         /* ԗ */
									memcpy(men,hkyokumen,100);
									K82 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 4:         /* 򍁗 */
									memcpy(men,hkyokumen,100);
									K82 = K11 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 5:         /* 񖇗 */
									memcpy(men,hkyokumen,100);
									K82 = K22 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 6:         /* l */
									memcpy(men,hkyokumen,100);
									K11 = K91 = K22 = K82 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 7:         /* Z */
									memcpy(men,hkyokumen,100);
									K11 = K21 = K81 = K91 = K22 = K82 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								default:
									tesu = teban_flag = 0;
									iprog = 15;
									break;
								}
								break;
							}
						}
					}
					break;
				case 15:
					if (strncmp(moji,"̎F",12) == 0)
					{
						komadai(&moji[12],&men[90]);
						iprog++;
						break;
					}
					else if (moji[0] == '|')
					{
						iprog++;
					}
				case 16:
				case 17:
				case 18:
				case 19:
				case 20:
				case 21:
				case 22:
				case 23:
				case 24:
					if (moji[0] != '|')
					{
						break;
					}
					j = (iprog - 15) * 9;
					s = moji + 1;
					for (i = 0 ; i < 9 ; i++)
					{
						koma = get_koma_code(&s[1]
									,"Ejpʂƈǌ\Sn");
						if (koma == 16)koma = 15;
						switch(*s)
						{
						case 'v':
						case 'V':
							if (koma == 8)PGOU = j;
							men[j--] = -koma;
							break;
						default:
							if (koma == 8)PSOU = j;
							men[j--] = koma;
							break;
						}
						s += 3;
					}
					iprog++;
					break;
				case 25:
					if (strncmp(moji,"̎F",12) == 0)
					{
						komadai(&moji[12],&men[82]);
						iprog++;
					}
					break;
				case 26:
					if (strncmp(moji,"̎F",12) == 0)
					{
						komadai(&moji[12],&men[90]);
						iprog++;
						break;
					}
					if (strncmp(moji,"",6) == 0)
					{
						tesu = teban_flag = 1;
						break;
					}
					else if(strncmp(moji,"F",6) == 0)
					{
						get_moji(ssman,&moji[6],20);
						break;
					}
					else if(strncmp(moji,"F",6) == 0)
					{
						get_moji(ssman,&moji[6],20);
						break;
					}
					else if(strncmp(moji,"F",6) == 0)
					{
						get_moji(ggman,&moji[6],20);
						break;
					}
					else if(strncmp(moji,"F",6) == 0)
					{
						get_moji(ggman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"萔-",5) == 0)
					{
						te = teban_flag;
						kifu[te][0] = 0;
						ix_old = iy_old = 0;
						end_code = 0;
						memcpy(initial_kyokumen,men,100);
						memcpy(men_h,men,100);
						sman2[0] = gman2[0] = 0;
						strcopy(sman,ssman);
						strcopy(gman,ggman);
						iprog++;
					}
					break;
				case 27:
					len = strlen(moji);
					if (len < 6)break;
					s = moji + 5;
					if (strncmp(s,"",4) == 0)
					{
						if (te & 0x01)
						{
							end_code = 1;
						}
						else
						{
							end_code = 2;
						}
						iprog++;
						iexit = 1;
						break;
					}
					else if (strncmp(s,"l",2) == 0)
					{
						if (te & 0x01)
						{
							end_code = 1;
						}
						else
						{
							end_code = 2;
						}
						iprog++;
						iexit = 1;
						break;
					}
					else if (strncmp(s,"f",4) == 0)
					{
						end_code = 0;
						iprog++;
						iexit = 1;
						break;
					}
					else if (strncmp(s,"",6) == 0)
					{
						end_code = 3;
						iprog++;
						iexit = 1;
						break;
					}
					else if (strncmp(s,"",6) == 0)
					{
						end_code = 4;
						iprog++;
						iexit = 1;
						break;
					}

					/**************/
					/* VWϊ */
					/**************/

					if (strncmp(s,"",2) == 0)
					{
						ix_new = ix_old;
						iy_new = iy_old;
					}
					else
					{
						ix_new = get_koma_code(s,"@PQRSTUVWX");
						if (ix_new == 0)
						{
							iprog++;
							break;
						}
						iy_new = get_koma_code(&s[2],"@OlܘZ");
						if (iy_new == 0)
						{
							iprog++;
							break;
						}
					}

					/**************/
					/* Wϊ */
					/**************/

					if (strncmp(&s[6],"",2) == 0)
					{
						naru   = 0;
						iy_old = 1;
						ix_old = get_koma_code(&s[4],"@jp") + UCHI_KOMA;
						if (ix_old == UCHI_KOMA)
						{
							iprog++;
							break;
						}
					}
					else if (strncmp(&s[6],"",2) == 0)
					{
						naru   = NARU_CODE;
						ix_old = get_koma_code(&s[8],"@(1(2(3(4(5(6(7(8(9");
						if (ix_old == 0)
						{
							iprog++;
							break;
						}
						iy_old = get_koma_code(&s[10],"@1)2)3)4)5)6)7)8)9)");
						if (iy_old == 0)
						{
							iprog++;
							break;
						}
					}
					else if (strncmp(&s[4],"",2) == 0)
					{
						naru   = 0;
						ix_old = get_koma_code(&s[8],"@(1(2(3(4(5(6(7(8(9");
						if (ix_old == 0)
						{
							iprog++;
							break;
						}
						iy_old = get_koma_code(&s[10],"@1)2)3)4)5)6)7)8)9)");
						if (iy_old == 0)
						{
							iprog++;
							break;
						}
					}
					else
					{
						naru = 0;
						ix_old = get_koma_code(&s[6],"@(1(2(3(4(5(6(7(8(9");
						if (ix_old == 0)
						{
							iprog++;
							break;
						}
						iy_old = get_koma_code(&s[8],"@1)2)3)4)5)6)7)8)9)");
						if (iy_old == 0)
						{
							iprog++;
							break;
						}
					}

					/******************/
					/* f[^o^ */
					/******************/
					kifu[te + 1][0] = 0;
					kifu[te][0] = iy_new * 9 + ix_new - 9 + naru;
					kifu[te][1] = iy_old * 9 + ix_old - 9;
					shohi[te] = get_kakinoki_shohi(moji);
					ix_old = ix_new;
					iy_old = iy_new;
					te++;
					if (te >= 3000)
					{
						iexit = 1;
						break;
					}
					break;
        		default:
					break;
				}
				if (iexit)break;
			}
			if (iprog < 13)
			{
				::PostMessage(m_hWnd,WM_FILE,te,1);
			}
			else
			{
				::PostMessage(m_hWnd,WM_FILE,te,3);
			}
			break;
		case 2:
			iprog = cr_cnt = 0;
			while(mgets(moji,sizeof(moji),ar))
			{
				switch(iprog)
				{
				case 1:
					if (moji[0] == 'N')
					{
						if (moji[1] == '-')
						{
							if (utf2sjis(moji,sjis))
							{
								if (strncmp(&sjis[2],":",5) == 0)
								{
									strcpy_s(&moji[2],sizeof(moji) - 2,&sjis[7]);
								}
							}
							get_moji_unix(ggman,&moji[2],20);
							mchange(ggman);
							iprog++;
						}
					}
					break;
				case 0:
					if (moji[0] == 'N')
					{
						if (moji[1] == '+')
						{
							if (utf2sjis(moji,sjis))
							{
								if (strncmp(&sjis[2],":",5) == 0)
								{
									strcpy_s(&moji[2],sizeof(moji) - 2,&sjis[7]);
								}
							}
							get_moji_unix(ssman,&moji[2],20);
							mchange(ssman);
							iprog++;
							break;
						}
					}
				case 2:
					if (moji[1] == 'I')break;
				case 3:
				case 4:
				case 5:
				case 6:
				case 7:
				case 8:
				case 9:
				case 10:
				case 11:
					if (moji[0] == 'P')
					{
						if (iprog <= 2)
						{
							iprog = 3;
						}
						else
						{
							if (moji[1] == '+')break;
							if (moji[1] == '-')break;
							iprog++;
						}
						s = moji + 2;
						ip = (iprog - 2) * 9;
						for (i = 0 ; i < 9 ; i++)
						{
							switch(*s++)
							{
							case '+':
								men[ip--] = csa_koma_code(s);
								s += 2;
								break;
							case '-':
								men[ip--] = -csa_koma_code(s);
								s += 2;
								break;
							case '*':
								men[ip--] = 0;
								if (*s == '*')
								{
									s += 2;
								}
								else
								{
									s++;
								}
								break;
							default:
								men[ip--] = 0;
								s += 2;
								break;
							}
						}
						break;
					}
				case 12:	// ????
				case 13:
					switch(moji[0])
					{
					case '+':
					case '-':
						if (iprog <= 2)
						{
							memcpy(men,hkyokumen,100);
						}
						else
						{
							for (i = 1 ; i <= 81 ;i++)
							{
								switch(men[i])
								{
								case SOU:
									PSOU = i;
									break;
								case GOU:
									PGOU = i;
									break;
								default:
									break;
								}
							}
						}
						if (moji[0] == '+')
						{
							tesu = teban_flag = 0;
						}
						else
						{
							tesu = teban_flag = 1;
						}
						iprog = 14;
					}
					mochi_flag = 0;
					kifu[tesu][0] = 0;
					end_code = 0;
					memcpy(initial_kyokumen,men,100);
					memcpy(men_h,men,100);
					te = teban_flag;
					sman2[0] = gman2[0] = 0;
					strcopy(sman,ssman);
					strcopy(gman,ggman);
					timer_sec[0] = timer_sec[1] = 0;
					if (moji[1] == 0)break;
				case 14:                        /* w */
					switch (moji[0])
					{
					case '%':
						if (mochi_flag)
						{
							te++;
						}
						kifu[te][0] = 0;
						if (moji[1] == 'T')
						{
							if (te & 0x0001)
							{
								end_code = 1;
							}
							else
							{
								end_code = 2;
							}
						}
						else
						{
							end_code = 0;
						}
						iexit = 1;
						break;
					case 'T':			// 
						if (mochi_flag)
						{
							mochi_flag = 0;
							v = atoi(&moji[1]);
							shohi[te] += v;
							te++;
						}
						break;
					case '+':
						if (te >= 3000)
						{
							end_code = 0;
							iexit    = 1;
							break;
						}
						if (te & 0x0001)
						{
							te++;
						}
						kifu[te + 1][0] = 0;
						if (moji[1] == '0')		// ŋ
						{
							if (moji[2] == '0')
							{
								k = csa_koma_code(&moji[5]);
							}
							else
							{
								k = csa_koma_code(&moji[4]);	// W΍
							}
							v = atoi(&moji[2]);
							kifu[te][1] = UCHI_KOMA + k;
							ix = v / 10;
							iy = v % 10;
							ip = (iy - 1) * 9 + ix;
							kifu[te][0] = ip;
						}
						else
						{
							k = csa_koma_code(&moji[5]);
							v = atoi(&moji[1]);
							old  = v / 100;
                			newx = v % 100;
							ix = old / 10;
							iy = old % 10;
							i = (iy - 1) * 9 + ix;
							kifu[te][1] = (iy - 1) * 9 + ix;
							ix = newx / 10;
							iy = newx % 10;
							ip = (iy - 1) * 9 + ix;
							kifu[te][0] = ip;
							if (men[i] != k)
							{
								kifu[te][0] += NARU_CODE;
							}
							men[i] = 0;
						}
						men[ip] = k;
						if ((te - 2) >= teban_flag)
						{
							shohi[te] = shohi[te - 2];
						}
						else
						{
							shohi[te] = 0;
						}
						mochi_flag = 1;
						if (moji[7] == ',')
						{
							if (moji[8] == 'T')
							{
								mochi_flag = 0;
								v = atoi(&moji[9]);
								shohi[te] += v;
								te++;
							}
						}
						break;
					case '-':
						if (te >= 3000)
						{
							end_code = 0;
							iexit    = 1;
							break;
						}
						if ((te & 0x0001) == 0)
						{
							te++;
						}
						kifu[te + 1][0] = 0;
						if (moji[1] == '0')		// ŋ
						{
							if (moji[2] == '0')
							{
								k = csa_koma_code(&moji[5]);
							}
							else
							{
								k = csa_koma_code(&moji[4]);	// W΍
							}
							v = atoi(&moji[2]);
							kifu[te][1] = UCHI_KOMA + k;
							ix = v / 10;
							iy = v % 10;
							ip = (iy - 1) * 9 + ix;
							kifu[te][0] = ip;
							k = -k;
						}
						else
						{
							k = -csa_koma_code(&moji[5]);
							v = atoi(&moji[1]);
							old  = v / 100;
							newx = v % 100;
							ix  = old / 10;
							iy  = old % 10;
							i  = (iy - 1) * 9 + ix;
							kifu[te][1] = (iy - 1) * 9 + ix;
							ix  = newx / 10;
							iy  = newx % 10;
							ip = (iy - 1) * 9 + ix;
							kifu[te][0] = ip;
							if (men[i] != k)
							{
								kifu[te][0] += NARU_CODE;
							}
							men[i] = 0;
						}
						men[ip] = k;
						if ((te - 2) >= teban_flag)
						{
							shohi[te] = shohi[te - 2];
						}
						else
						{
							shohi[te] = 0;
						}
						mochi_flag = 1;
						if (moji[7] == ',')
						{
							if (moji[8] == 'T')
							{
								mochi_flag = 0;
								v = atoi(&moji[9]);
								shohi[te] += v;
								te++;
							}
						}
						break;
					}
					break;
				default:
					break;
				}
				if (iexit)break;
			}
			if (iprog == 14)
			{
				::PostMessage(m_hWnd,WM_FILE,te,2);
			}
			break;
		default:
			break;
		}
	}
}


// COkiDoc ff

#ifdef _DEBUG
void COkiDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void COkiDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// COkiDoc R}h
BOOL COkiDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	itype = GetType((char *)lpszPathName);

	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
		
	return TRUE;
}

BOOL COkiDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	itype = GetType((char *)lpszPathName);

	return CDocument::OnSaveDocument(lpszPathName);
}

int	COkiDoc::GetType(char *filename) 
{
	int		kotae;
	int		len;

	kotae = 0;
	len   = strlen(filename);

	if (len > 4)
	{
		if (filename[len - 4] == '.')
		{
			switch(filename[len - 3])
			{
			case 'K':
			case 'k':
				switch(filename[len - 2])
				{
				case 'I':
				case 'i':
					switch(filename[len - 1])
					{
					case 'F':
					case 'f':
						kotae = 1;
						break;
					default:
						break;
					}
					break;
				default:
					break;
				}
				break;
			case 'C':
			case 'c':
				switch(filename[len - 2])
				{
				case 'S':
				case 's':
					switch(filename[len - 1])
					{
					case 'A':
					case 'a':
						kotae = 2;
						break;
					default:
						break;
					}
					break;
				default:
					break;
				}
				break;
			default:
				break;
			}
		}
	}

	return kotae;
}

int COkiDoc::moji_size(unsigned char c)
{
    if (c < 0x0020)return(0);
    if (c < 0x007f)return(1);
    if (c < 0x0081)return(0);
    if (c < 0x00a0)return(2);
    if (c < 0x00a1)return(0);
    if (c < 0x00e0)return(1);
    if (c < 0x00fd)return(2);
    return(0);
}

/**************/
/* 擾 */
/**************/
void COkiDoc::get_moji(char *s2,char *s1,int max)
{
    int    len;
    int    iend;

    len  = 0;
    iend = 1;

    while(iend)
    {
        switch(moji_size(*s1))
        {
        case 1:
            if (len >= max)
            {
                iend = 0;
                break;
            }
            *s2++ = *s1++;
            len++;
            break;
        case 2:
            if ((len + 1) >= max)
            {
                iend = 0;
                break;
            }
            *s2++ = *s1++;
            *s2++ = *s1++;
            len += 2;
            break;
        default:
            iend = 0;
            break;
        }
    }
    *s2 = 0;
}

/***********************************************************************/
/* 擾iunix̉\̂ŁAǂ̓`FbNȂB) */
/***********************************************************************/

void COkiDoc::get_moji_unix(char *s2,char *s1,int max)
{
    int    len;

    len  = 0;

    while(*s1)
    {
		if (len >= max)
        {
			break;
		}
		*s2++ = *s1++;
		len++;
	}
    *s2 = 0;
}

/*******************************/
/* tab yspaceJbgB */
/*******************************/

void COkiDoc::tab_cut(char *s)
{
	char	*s1;

	s1 = s;
	while(*s)
	{
		switch(*s)
		{
		case ' ':
		case '\t':
			s++;
			break;
		default:
			*s1++ = *s++;
			break;
		}
	}
	*s1 = 0;
}

void COkiDoc::get_date(char *s)
{
	int		kotae;
	int		idata;

	kotae = 0;

	while(1)
	{
		idata = -1;
		switch(*s)
		{
		case '0':
			idata = 0;
			break;
		case '1':
			idata = 1;
			break;
		case '2':
			idata = 2;
			break;
		case '3':
			idata = 3;
			break;
		case '4':
			idata = 4;
			break;
		case '5':
			idata = 5;
			break;
		case '6':
			idata = 6;
			break;
		case '7':
			idata = 7;
			break;
		case '8':
			idata = 8;
			break;
		case '9':
			idata = 9;
			break;
		default:
			if (*s == '/')
			{
				s++;
			}
			else if (strncmp(s,"N",2) == 0)
			{
				s += 2;
			}
			break;
		}
		if (idata < 0)break;
		kotae = kotae * 10 + idata;
		s++;
	}
	if (kotae == 0)return;

	nen = kotae;

	kotae = 0;

	while(1)
	{
		idata = -1;
		switch(*s)
		{
		case '0':
			idata = 0;
			break;
		case '1':
			idata = 1;
			break;
		case '2':
			idata = 2;
			break;
		case '3':
			idata = 3;
			break;
		case '4':
			idata = 4;
			break;
		case '5':
			idata = 5;
			break;
		case '6':
			idata = 6;
			break;
		case '7':
			idata = 7;
			break;
		case '8':
			idata = 8;
			break;
		case '9':
			idata = 9;
			break;
		default:
			if (*s == '/')
			{
				s++;
			}
			else if (strncmp(s,"",2) == 0)
			{
				s += 2;
			}
			break;
		}
		if (idata < 0)break;
		kotae = kotae * 10 + idata;
		s++;
	}
	if (kotae == 0)return;
	tsuki = kotae;

	kotae = 0;

	while(1)
	{
		idata = -1;
		switch(*s)
		{
		case '0':
			idata = 0;
			break;
		case '1':
			idata = 1;
			break;
		case '2':
			idata = 2;
			break;
		case '3':
			idata = 3;
			break;
		case '4':
			idata = 4;
			break;
		case '5':
			idata = 5;
			break;
		case '6':
			idata = 6;
			break;
		case '7':
			idata = 7;
			break;
		case '8':
			idata = 8;
			break;
		case '9':
			idata = 9;
			break;
		default:
			break;
		}
		if (idata < 0)break;
		kotae = kotae * 10 + idata;
		s++;
	}
	if (kotae == 0)return;
	hi = kotae;
}

void COkiDoc::kmove(int teban,char *m,int men[10][10],int mochi[2][8])
{
    int     ix_min;
    int     ix_max;
    int     iy_min;
    int     iy_max;
    int     ix;
    int     iy;
    int     i;
    int     koma;
    int     iflag1;
    int     iflag2;
    int     iflag3;
    int     iflag4;
    int     iflag5;
    int     iflag6;
    int     iflag7;
    int     iflag8;
	char	*kmoji;

	naru_flag = 0;

	/* ʒuf */
	if (strncmp(m,"",2) == 0)
	{
		m += 2;
		if (strncmp(m,"@",2) == 0)m += 2;        /* WH搶Ή */
	}
    else
    {
        for (i = 0 ; i < 18 ; i += 2)
        {
            if (strncmp(m,&xmoji[i],2) == 0)
            {
                ix_new = i / 2 + 1;
                break;
            }
        }
        m += 2;
        for (i = 0 ; i < 18 ; i += 2)
        {
            if (strncmp(m,&ymoji[i],2) == 0)
            {
                iy_new = i / 2 + 1;
                break;
            }
        }
        m += 2;
    }

	/* f */
	kmoji = kakinoki_koma + 2;
    if (strncmp(m,nari,2) == 0)
    {
        koma = 8;
        m += 2;
    }
    else
    {
        koma = 0;
    }

    if (strncmp(m,"",2) == 0)
    {
        koma = 9;
        m += 2;
    }
    else if (strncmp(m,"n",2) == 0)
    {
        koma = 14;
        m += 2;
    }
    else if (strncmp(m,"",2) == 0)
    {
        koma = 15;
        m += 2;
    }
    else
    {
        for (i = 0 ; i < 16 ; i += 2)
        {
            if (strncmp(m,&kmoji[i],2) == 0)
            {
                koma = i / 2 + 1 + koma;
                m += 2;
                break;
            }
        }
    }

    koma = teban * 16 + koma;

// Ń`FbN
    if (strncmp(m,"",2) == 0)
    {
        men[ix_new][iy_new] = koma;
        koma &= 0x0007;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
        return;
    }

/* B */
    switch (koma)
    {
    case 1: /* @ */
        if (iy_new == 9)
        {
            men[ix_new][iy_new] = koma;
            mochi[teban][koma]--;
            ix_old = 0;
            iy_old = koma;
        }
        else if (men[ix_new][iy_new + 1] == koma)
        {
            ix_old = ix_new;
            iy_old = iy_new + 1;
            men[ix_new][iy_new + 1] = 0;
            iy = men[ix_new][iy_new] & 0x0007;
            if (iy > 0)
            {
                mochi[teban][iy]++;
            }
            if (strncmp(m,nari,2) == 0)
            {
                naru_flag = 1;
                koma |= 0x0008;
            }
            men[ix_new][iy_new] = koma;
        }
        else
        {
            ix_old = 0;
            iy_old = koma;
            men[ix_new][iy_new] = koma;
            mochi[teban][koma]--;
        }
        return;
    case 17: /* @ */
        if (iy_new == 1)
        {
            men[ix_new][1] = koma;
            koma &= 0x0007;
            ix_old = 0;
            iy_old = koma;
            mochi[teban][koma]--;
        }
        else if (men[ix_new][iy_new - 1] == koma)
        {
            ix_old = ix_new;
            iy_old = iy_new - 1;
            men[ix_new][iy_new - 1] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            if (strncmp(m,nari,2) == 0)
            {
                naru_flag = 1;
                koma |= 0x0008;
            }
            men[ix_new][iy_new] = koma;
        }
        else
        {
            men[ix_new][iy_new] = koma;
            koma &= 0x0007;
            ix_old = 0;
            iy_old = koma;
            mochi[teban][koma]--;
        }
        return;
    case 2: /* @ */
        for (iy =  iy_new + 1; iy < 10 ; iy++)
        {
            if(men[ix_new][iy] == koma)
            {
                ix_old = ix_new;
                iy_old = iy;
                men[ix_new][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix_new][iy] != 0)
            {
                ix_old = 0;
                iy_old = koma;
                men[ix_new][iy_new] = koma;
                mochi[teban][koma]--;
                return;
            }
        }
        ix_old = 0;
        iy_old = koma;
        men[ix_new][iy_new] = koma;
        mochi[teban][koma]--;
        return;
    case 18: /* @ */
        for (iy =  iy_new - 1; iy > 0 ; iy--)
        {
            if(men[ix_new][iy] == koma)
            {
                ix_old = ix_new;
                iy_old = iy;
                men[ix_new][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix_new][iy] != 0)
            {
                men[ix_new][iy_new] = koma;
                koma &= 0x0007;
                ix_old = 0;
                iy_old = koma;
                mochi[teban][koma]--;
                return;
            }
        }
        men[ix_new][iy_new] = koma;
        koma &= 0x0007;
        ix_old = 0;
        iy_old = koma;
        mochi[teban][koma]--;
        return;
    case 3: /* @j */
        if  (strncmp(m,"E",2) == 0)
        {
            m += 2;
            ix_old = ix_new - 1;
            iy_old = iy_new + 2;
            men[ix_new - 1][iy_new + 2] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            if (strncmp(m,nari,2) == 0)
            {
                naru_flag = 1;
                koma |= 0x0008;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        if  (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_old = ix_new + 1;
            iy_old = iy_new + 2;
            men[ix_new + 1][iy_new + 2] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            if (strncmp(m,nari,2) == 0)
            {
                naru_flag = 1;
                koma |= 0x0008;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        ix = ix_new - 1;
        iy = iy_new + 2;
        if (ix > 0 && iy < 10)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new + 1;
        if (ix < 10 && iy < 10)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        men[ix_new][iy_new] = koma;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
        return;
    case 19: /* @j */
        if  (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_old = ix_new - 1;
            iy_old = iy_new - 2;
            men[ix_new - 1][iy_new - 2] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            if (strncmp(m,nari,2) == 0)
            {
                naru_flag = 1;
                koma |= 0x0008;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        if  (strncmp(m,"E",2) == 0)
        {
            m += 2;
            ix_old = ix_new + 1;
            iy_old = iy_new - 2;
            men[ix_new + 1][iy_new - 2] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            if (strncmp(m,nari,2) == 0)
            {
                naru_flag = 1;
                koma |= 0x0008;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        ix = ix_new - 1;
        iy = iy_new - 2;
        if (ix > 0 && iy > 0)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new + 1;
        if (ix < 10 && iy > 0)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        men[ix_new][iy_new] = koma;
        koma &= 0x0007;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
        return;
    case 4:  /* @ */
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_old = ix_new;
            iy_old = iy_new + 1;
            men[ix_new][iy_new + 1] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            if (strncmp(m,nari,2) == 0)
            {
               naru_flag = 1;
               koma |= 0x0008;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        ix_min = ix_new - 1;
        ix_max = ix_new + 1;
        iy_min = iy_new - 1;
        iy_max = iy_new + 1;
        if (strncmp(m,"E",2) == 0)
        {
            m += 2;
            ix_max = ix_min;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_min = ix_max;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_min = iy_max;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_max = iy_min;
        }
        for (ix = ix_min; ix <= ix_max ; ix++)
        {
            if (ix < 1)continue;
            if (ix > 9)continue;
            for (iy = iy_min; iy <= iy_max ; iy += 2)
            {
                if (iy < 1)continue;
                if (iy > 9)continue;
                if (ix == ix_new && iy == iy_new - 1)continue;
                if (men[ix][iy] == koma)
                {
                    ix_old = ix;
                    iy_old = iy;
                    men[ix][iy] = 0;
                    i = men[ix_new][iy_new] & 0x0007;
                    if( i > 0)
                    {
                        mochi[teban][i]++;
                    }
                    if (strncmp(m,nari,2) == 0)
                    {
                        naru_flag = 1;
                        koma |= 0x0008;
                    }
                    men[ix_new][iy_new] = koma;
                    return;
                }
            }
        }
        men[ix_new][iy_new] = koma;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
        return;
    case 20: /* @ */
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_old = ix_new;
            iy_old = iy_new - 1;
            men[ix_new][iy_new - 1] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            if (strncmp(m,nari,2) == 0)
            {
               naru_flag = 1;
               koma |= 0x0008;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        ix_min = ix_new - 1;
        ix_max = ix_new + 1;
        iy_min = iy_new - 1;
        iy_max = iy_new + 1;
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_max = ix_min;
        }
        if (strncmp(m,"E",2) == 0)
        {
            m += 2;
            ix_min = ix_max;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_min = iy_max;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_max = iy_min;
        }
        for (ix = ix_max; ix >= ix_min ; ix--)
        {
            if (ix < 1)continue;
            if (ix > 9)continue;
            for (iy = iy_min; iy <= iy_max ; iy += 2)
            {
                if (iy < 1)continue;
                if (iy > 9)continue;
                if (ix == ix_new && iy == iy_new + 1)continue;
                if (men[ix][iy] == koma)
                {
                    ix_old = ix;
                    iy_old = iy;
                    men[ix][iy] = 0;
                    i = men[ix_new][iy_new] & 0x0007;
                    if( i > 0)
                    {
                        mochi[teban][i]++;
                    }
                    if (strncmp(m,nari,2) == 0)
                    {
                        naru_flag = 1;
                        koma |= 0x0008;
                    }
                    men[ix_new][iy_new] = koma;
                    return;
                }
            }
        }
        men[ix_new][iy_new] = koma;
        koma &= 0x0007;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
        return;
    case 5:  /* @EƁEEjE */
    case 9:
    case 10:
    case 11:
    case 12:
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_old = ix_new;
            iy_old = iy_new + 1;
            men[ix_new][iy_new + 1] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        ix_min = ix_new - 1;
        ix_max = ix_new + 1;
        iy_min = iy_new - 1;
        iy_max = iy_new + 1;
        if (strncmp(m,"E",2) == 0)
        {
            m += 2;
            ix_max = ix_min;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_min = ix_max;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_min = iy_max;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_max = iy_min;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_min = iy_max = iy_new;
        }
        for (ix = ix_min; ix <= ix_max ; ix++)
        {
            if (ix < 1)continue;
            if (ix > 9)continue;
            for (iy = iy_min; iy <= iy_max ; iy ++)
            {
                if (iy < 1)continue;
                if (iy > 9)continue;
                if (ix == ix_new && iy == iy_new)continue;
                if (ix != ix_new && iy == iy_new - 1)continue;
                if (men[ix][iy] == koma)
                {
                    ix_old = ix;
                    iy_old = iy;
                    men[ix][iy] = 0;
                    i = men[ix_new][iy_new] & 0x0007;
                    if( i > 0)
                    {
                        mochi[teban][i]++;
                    }
                    men[ix_new][iy_new] = koma;
                    return;
                }
            }
        }
        men[ix_new][iy_new] = koma;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
        return;
    case 21: /* @EƁEEjE */
    case 25:
    case 26:
    case 27:
    case 28:
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_old = ix_new;
            iy_old = iy_new - 1;
            men[ix_new][iy_new - 1] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        ix_min = ix_new - 1;
        ix_max = ix_new + 1;
        iy_min = iy_new - 1;
        iy_max = iy_new + 1;
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_max = ix_min;
        }
        if (strncmp(m,"E",2) == 0)
        {
            m += 2;
            ix_min = ix_max;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_min = iy_max;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_max = iy_min;
        }
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            iy_min = iy_max = iy_new;
        }
        for (ix = ix_max; ix >= ix_min ; ix--)
        {
            if (ix < 1)continue;
            if (ix > 9)continue;
            for (iy = iy_min; iy <= iy_max ; iy ++)
            {
                if (iy < 1)continue;
                if (iy > 9)continue;
                if (ix == ix_new && iy == iy_new)continue;
                if (ix != ix_new && iy == iy_new + 1)continue;
                if (men[ix][iy] == koma)
                {
                    ix_old = ix;
                    iy_old = iy;
                    men[ix][iy] = 0;
                    i = men[ix_new][iy_new] & 0x0007;
                    if( i > 0)
                    {
                        mochi[teban][i]++;
                    }
                    men[ix_new][iy_new] = koma;
                    return;
                }
            }
        }
        men[ix_new][iy_new] = koma;
        koma &= 0x0007;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
        return;
    case 6:  /* @p */
        iflag1 = iflag2 = iflag3 = iflag4 = 1;
        if (strncmp(m,"E",2) == 0)
        {
            m +=2;
            iflag3 = iflag4 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag4 = 0;
        }
        if (strncmp(m,"s",2) == 0)
        {
            m +=2;
            iflag1 = iflag4 = 0;
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag1)
        {
            ix--;
            if(ix < 1) break;
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag2)
        {
            ix--;
            if(ix < 1)break;
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag3)
        {
            ix++;
            if(ix > 9) break;
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag4)
        {
            ix++;
            if(ix > 9) break;
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        men[ix_new][iy_new] = koma;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
        return;
    case 22: /* @p */
        iflag1 = iflag2 = iflag3 = iflag4 = 1;
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag3 = iflag4 = 0;
        }
        if (strncmp(m,"E",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = 0;
        }
        if (strncmp(m,"s",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag4 = 0;
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag1)
        {
            ix--;
            if(ix < 1) break;
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag2)
        {
            ix--;
            if(ix < 1) break;
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag3)
        {
            ix++;
            if(ix > 9) break;
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag4)
        {
            ix++;
            if(ix > 9) break;
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        men[ix_new][iy_new] = koma;
        koma &= 0x0007;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
        return;
    case 14: /* @n */
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_old = ix_new;
            iy_old = iy_new + 1;
            men[ix_new][iy_new + 1] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        iflag1 = iflag2 = iflag3 = iflag4 = 1;
        iflag5 = iflag6 = iflag7 = iflag8 = 1;
        if (strncmp(m,"E",2) == 0)
        {
            m +=2;
            iflag3 = iflag4 = 0;
            iflag5 = iflag6 = iflag8 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = 0;
            iflag6 = iflag7 = iflag8 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = 0;
            iflag5 = iflag6 = iflag7 = 0;
			if (men[ix_new][iy_new - 1] == koma)iflag1 = iflag4 = 0;	/* BUG 1998/01/14 */
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag4 = 0;
            iflag5 = iflag7 = iflag8 = 0;
        }
        if (strncmp(m,"s",2) == 0)
        {
            m +=2;
            iflag1 = iflag4 = 0;
            iflag5 = iflag7 = iflag8 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag3 = iflag4 = 0;
            iflag6 = iflag8 = 0;
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag1)
        {
            ix--;
            if(ix < 1) break;
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag2)
        {
            ix--;
            if(ix < 1) break;
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag3)
        {
            ix++;
            if(ix > 9) break;
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag4)
        {
            ix++;
            if(ix > 9) break;
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new + 1;
        iy = iy_new;
        if (iflag5 == 1 && ix <= 9)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new;
        iy = iy_new + 1;
        if (iflag6 == 1 && iy <= 9)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new - 1;
        iy = iy_new;
        if (iflag7 == 1 && ix >= 1)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new;
        iy = iy_new - 1;
        if (iflag8 == 1 && iy >= 1)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
            }
        }
        return;
    case 30: /* @n */
        if (strncmp(m,"",2) == 0)
        {
            m += 2;
            ix_old = ix_new;
            iy_old = iy_new - 1;
            men[ix_new][iy_new - 1] = 0;
            i = men[ix_new][iy_new] & 0x0007;
            if (i > 0)
            {
                mochi[teban][i]++;
            }
            men[ix_new][iy_new] = koma;
            return;
        }
        iflag1 = iflag2 = iflag3 = iflag4 = 1;
        iflag5 = iflag6 = iflag7 = iflag8 = 1;
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag3 = iflag4 = 0;
            iflag5 = iflag6 = iflag8 = 0;
        }
        if (strncmp(m,"E",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = 0;
            iflag6 = iflag7 = iflag8 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = 0;
            iflag5 = iflag6 = iflag7 = 0;
        }
        if (strncmp(m,"s",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = 0;
            iflag5 = iflag6 = iflag7 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag4 = 0;
            iflag5 = iflag7 = iflag8 = 0;
			if (men[ix_new][iy_new + 1] == koma)iflag2 = iflag3 = 0;	/* BUG 1998/01/14 */
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag3 = iflag4 = 0;
            iflag6 = iflag8 = 0;
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag1)
        {
            ix--;
            if(ix < 1) break;
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag2)
        {
            ix--;
            if(ix < 1) break;
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag3)
        {
            ix++;
            if(ix > 9) break;
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag4)
        {
            ix++;
            if(ix > 9) break;
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new + 1;
        iy = iy_new;
        if (iflag5 == 1 && ix <= 9)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new;
        iy = iy_new + 1;
        if (iflag6 == 1 && iy <= 9)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new - 1;
        iy = iy_new;
        if (iflag7 == 1 && ix >= 1)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new;
        iy = iy_new - 1;
        if (iflag8 == 1 && iy >= 1)
        {
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
            }
        }
        return;
    case 7:  /* @ */
		sente_hi(teban,m,men,mochi,ix_new,iy_new,koma);
		return;
    case 23: /* @ */
		gote_hi(teban,m,men,mochi,ix_new,iy_new,koma);
        return;
    case 15: /* @ */
        iflag1 = iflag2 = iflag3 = iflag4 = 1;
        iflag5 = iflag6 = iflag7 = iflag8 = 1;
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag3 = 0;
            iflag5 = iflag6 = iflag7 = iflag8 = 0;
        }
        if (strncmp(m,"E",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag4 = 0;
            iflag7 = iflag8 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = iflag4 = 0;
            iflag5 = iflag6 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag3 = iflag4 = 0;
            iflag5 = iflag8 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag3 = 0;
            iflag6 = iflag7 = 0;
        }
        if (strncmp(m,"s",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag3 = 0;
            iflag6 = iflag7 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag4 = 0;
            iflag5 = iflag6 = iflag7 = iflag8 = 0;
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag1)
        {
            ix++;
            if(ix > 9) break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag2)
        {
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag3)
        {
            ix--;
            if(ix < 1) break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag4)
        {
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new - 1;
        iy = iy_new + 1;
        if ((ix > 0) && (iy < 10) && (iflag5 == 1))
        {
            if(men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new - 1;
        iy = iy_new - 1;
        if ((ix > 0) && (iy > 0) && (iflag6 == 1))
        {
            if(men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new + 1;
        iy = iy_new - 1;
        if ((iy > 0) && (ix < 10) && (iflag7 == 1))
        {
            if(men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new + 1;
        iy = iy_new + 1;
        if ((ix < 10) && (iy < 10) && (iflag8 == 1))
        {
            if(men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
            }
        }
        return;
    case 31: /* @ */
        iflag1 = iflag2 = iflag3 = iflag4 = 1;
        iflag5 = iflag6 = iflag7 = iflag8 = 1;
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag3 = iflag4 = 0;
            iflag5 = iflag6 = iflag7 = iflag8 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag4 = 0;
            iflag7 = iflag8 = 0;
        }
        if (strncmp(m,"E",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = iflag4 = 0;
            iflag5 = iflag6 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag3 = iflag4 = 0;
            iflag5 = iflag8 = 0;
        }
        if (strncmp(m,"s",2) == 0)
        {
            m +=2;
            iflag1 = iflag3 = iflag4 = 0;
            iflag5 = iflag8 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag3 = 0;
            iflag6 = iflag7 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag4 = 0;
            iflag5 = iflag6 = iflag7 = iflag8 = 0;
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag1)
        {
            ix++;
            if(ix > 9) break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag2)
        {
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag3)
        {
            ix--;
            if(ix < 1) break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag4)
        {
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new - 1;
        iy = iy_new + 1;
        if ((ix > 0) && (iy < 10) && (iflag5 == 1))
        {
            if(men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new - 1;
        iy = iy_new - 1;
        if ((ix > 0) && (iy > 0) && (iflag6 == 1))
        {
            if(men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new + 1;
        iy = iy_new - 1;
        if ((iy > 0) && (ix < 10) && (iflag7 == 1))
        {
            if(men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
        }
        ix = ix_new + 1;
        iy = iy_new + 1;
        if ((ix < 10) && (iy < 10) && (iflag8 == 1))
        {
            if(men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                men[ix_new][iy_new] = koma;
            }
        }
        return;
    default: /*  */
        for (ix = ix_new - 1; ix <= ix_new + 1; ix++)
        {
            if (ix < 1)continue;
            for (iy = iy_new - 1; iy <= iy_new + 1 ; iy++)
            {
                if (iy < 1)continue;
                if (iy > 9)break;
                if(men[ix][iy] == koma)
                {
                    ix_old = ix;
                    iy_old = iy;
                    men[ix][iy] = 0;
                    i = men[ix_new][iy_new] & 0x0007;
                    if (i > 0)
                    {
                        mochi[teban][i]++;
                    }
                    men[ix_new][iy_new] = koma;
                    return;
                }
            }
        }
        break;
    }
}

void COkiDoc::sente_hi(int teban,char* m,int men[10][10],int mochi[2][8],int ix_new,int iy_new,int koma)
{
	int		i;
	int		ix;
	int		iy;
	int		iflag1;
	int		iflag2;
	int		iflag3;
	int		iflag4;

        iflag1 = iflag2 = iflag3 = iflag4 = 1;
        if (strncmp(m,"E",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag4 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = iflag4 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag3 = iflag4 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag3 = 0;
        }
        if (strncmp(m,"s",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag3 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag4 = 0;
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag1)
        {
            ix++;
            if(ix > 9) break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag2)
        {
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag3)
        {
            ix--;
            if(ix < 1) break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag4)
        {
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        men[ix_new][iy_new] = koma;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
}

void COkiDoc::gote_hi(int teban,char* m,int men[10][10],int mochi[2][8],
							int ix_new,int iy_new,int koma)
{
	int		i;
	int		ix;
	int		iy;
	int		iflag1;
	int		iflag2;
	int		iflag3;
	int		iflag4;

        iflag1 = iflag2 = iflag3 = iflag4 = 1;
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag4 = 0;
        }
        if (strncmp(m,"E",2) == 0)
        {
            m +=2;
            iflag2 = iflag3 = iflag4 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag3 = iflag4 = 0;
        }
        if (strncmp(m,"s",2) == 0)
        {
            m +=2;
            iflag1 = iflag3 = iflag4 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag1 = iflag2 = iflag3 = 0;
        }
        if (strncmp(m,"",2) == 0)
        {
            m +=2;
            iflag2 = iflag4 = 0;
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag1)
        {
            ix++;
            if(ix > 9) break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag2)
        {
            iy--;
            if(iy < 1)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag3)
        {
            ix--;
            if(ix < 1) break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        ix = ix_new;
        iy = iy_new;
        while(iflag4)
        {
            iy++;
            if(iy > 9)break;
            if (men[ix][iy] == koma)
            {
                ix_old = ix;
                iy_old = iy;
                men[ix][iy] = 0;
                i = men[ix_new][iy_new] & 0x0007;
                if (i > 0)
                {
                    mochi[teban][i]++;
                }
                if (strncmp(m,nari,2) == 0)
                {
                    naru_flag = 1;
                    koma |= 0x0008;
                }
                men[ix_new][iy_new] = koma;
                return;
            }
            else if (men[ix][iy] != 0)
            {
                break;
            }
        }
        men[ix_new][iy_new] = koma;
        koma &= 0x0007;
        mochi[teban][koma]--;
        ix_old = 0;
        iy_old = koma;
}

/* B̎ɕϊo^B */
void COkiDoc::touroku(int tesu)
{
	kifu[tesu + 1][0] = 0;
    kifu[tesu    ][0] = ix_new + (iy_new - 1) * 9 + naru_flag * NARU_CODE;
    if (ix_old == 0)
    {
        kifu[tesu][1] = iy_old + UCHI_KOMA;
    }
    else
    {
        kifu[tesu][1] = ix_old + (iy_old - 1) * 9;
    }
}

int COkiDoc::get_shohi(char *moji)
{
    int		hour;
    int		min;
    int		sec;

    sec  = 0;

	if (strlen(moji) >= 28)
	{
	    if (moji[18] != '(')return(sec);
    	if (moji[21] != ':')return(sec);
    	if (moji[24] != ':')return(sec);
    	if (moji[27] != ')')return(sec);
    	hour = atoi(&moji[19]);
    	min  = atoi(&moji[22]);
    	sec  = atoi(&moji[25]);
	}
	else if (strlen(moji) >= 26)
	{
    	if (moji[16] != '(')return(sec);
    	if (moji[19] != ':')return(sec);
    	if (moji[22] != ':')return(sec);
    	if (moji[25] != ')')return(sec);
    	hour = atoi(&moji[17]);
    	min  = atoi(&moji[20]);
    	sec  = atoi(&moji[23]);
	}
	else
	{
		return(sec);
	}
    return(hour * 3600 + min * 60 + sec);
}

/******************************************************/
/* \[Xt@CǂݍށBi}bLgbVΉj */
/******************************************************/
int COkiDoc::mgets(char* moji,int len,CArchive& ar)
{
	int		i;
	char	c;

	len--;
	i = 0;
	while(1)
	{
		if (i >= len)break;
		if (ar.Read(&c,1) <= 0)break;
		if (c == (char)0x0a)
		{
			if (i > 0)break;
		}
		else if (c == (char)0x0d)
		{
			cr_cnt++;
			if (i > 0)break;
		}
		else
		{
			moji[i++] = c;
		}
	}
	moji[i] = 0;
	return(i);
}

/*********************************************************************/
/* unix̃R[hǂ𒲂ׁAunixƔfoꍇdosɕϊB */
/*********************************************************************/

void COkiDoc::mchange(char *unix)
{
	int				k;
	int				t;
	int				flag;
	unsigned char	*u;
	unsigned char	*d;
	unsigned char	c;

	if (cr_cnt)
	{
		u    = (unsigned char *)unix;
		flag = 1;
		while(*u)
		{
			c = *u++;
			if (c < 0x00a1)return;
			if (c > 0x00fe)return;
			c = *u++;
			if (c < 0x00a1)return;
			if (c > 0x00fe)return;
			flag = 0;
		}
		if (flag)return;

		d = u = (unsigned char *)unix;
		while(*u)
		{
			k = (*u++) - 0x00a1;
			t = (*u++) - 0x00a1;
			if (k & 0x0001)
			{
				k >>= 1;
				k  += 129;
				t  += 159;
			}
			else
			{
				k >>= 1;
				k  += 129;
				t  += 64;
				if (t >= 127)t++;
			}
			*d++ = (unsigned char)k;
			*d++ = (unsigned char)t;
		}
	}
	else
	{
		u    = (unsigned char *)unix;
		flag = 1;
		while(*u)
		{
			c = *u++;
			if (c < 0x7f)continue;
			if (c < 0x00a1)return;
			if (c > 0x00fe)return;
			c = *u++;
			if (c < 0x00a1)return;
			if (c > 0x00fe)return;
			flag = 0;
		}
		if (flag)return;

		d = u = (unsigned char *)unix;
		while(*u)
		{
			c = *u++;
			if (c < 0x007f)
			{
				*d++ = c;
			}
			else
			{
				k = (*u++) - 0x00a1;
				t = (*u++) - 0x00a1;
				if (k & 0x0001)
				{
					k >>= 1;
					k  += 129;
					t  += 159;
				}
				else
				{
					k >>= 1;
					k  += 129;
					t  += 64;
					if (t >= 127)t++;
				}
				*d++ = (unsigned char)k;
				*d++ = (unsigned char)t;
			}
		}
	}
}

int COkiDoc::csa_koma_code(char* s)
{
	int		koma;

	switch(*s++)
	{
	case 'F':
		koma = 1;
		break;
	case 'K':
		switch(*s)
		{
		case 'Y':
			koma = 2;
			break;
		case 'E':
			koma = 3;
			break;
		case 'I':
			koma = 5;
			break;
		default:
			koma = 6;
			break;
		}
		break;
	case 'G':
		koma = 4;
		break;
	case 'H':
		koma = 7;
		break;
	case 'O':
		koma = 8;
		break;
	case 'T':
		koma = 9;
		break;
	case 'N':
		switch(*s)
		{
		case 'Y':
			koma = 10;
			break;
		case 'K':
			koma = 11;
			break;
		default:
			koma = 12;
			break;
		}
		break;
	case 'U':
		koma = 14;
		break;
	case 'R':
		koma = 15;
		break;
	default:
		koma = 0;
		break;
	}
	return(koma);
}

/**********************************************************************/
/*                                                                    */
/*   @\      @F@XcvZ[`                             */
/*                                                                    */
/*         @F@{q										  */
/*                                                   type         i/o */
/*   p[^@F@tesu  萔iO琔Bj    int           i  */
/*                   cmoji o͊                  char[20]      o  */
/*                                                                    */
/**********************************************************************/
void COkiDoc::kifuout(int tesu,char* cmoji)
{
    int         teban;
    int         koma;
    int         te;
    int         i_old;
    int         i_new;
    int         ix_old;
    int         iy_old;
    int         ix_new;
    int         iy_new;
    int         i_naru;
    int         i_mae;
	int         koma_old;
	int         i;
    int         ix;
    int         iy;
	int			men_kifu[9][9];
	int			mochi[2][8];
	char		ban[100];
	char		*hmen;

	/* o͕ */
	strcopy(cmoji,"                ");

	/* ǖʏ */
    memcpy(ban,initial_kyokumen,100);
    hmen = ban + 1;
    for (iy = 0 ; iy < 9 ; iy++)
    {
        for (ix = 0 ; ix < 9 ; ix++)
        {
            men_kifu[ix][iy] = *hmen++;
        }
    }

	/* 䏉 */
    for (teban = 0 ; teban < 2 ; teban++)
    {
        for (koma = 0 ; koma < 8 ; koma++)
        {
            mochi[teban][koma] = *hmen++;
        }
    }

	/* w萔̈O܂ŕׂB */
    i_new = -1;
    for (te = teban_flag ; te < tesu ; te++)
    {

        teban = te & 0x01;
        i_new = kifu[te][0];
        if (i_new == 0)return;
		if (i_new > NARU_CODE)
		{
			i_naru = 1;
			i_new -= NARU_CODE;
		}
		else
		{
			i_naru = 0;
		}
		i_new--;
		ix_new = i_new % 9;
		iy_new = i_new / 9;

		i_old = kifu[te][1];
		if (i_old < UCHI_KOMA)
		{
            i_old--;
            ix_old = i_old % 9;
            iy_old = i_old / 9;
        }

		/* Vʒű */
        koma = men_kifu[ix_new][iy_new];
        if (koma > 0)
        {
            koma &= 0x07;
            mochi[1][koma]++;
        }
        else if (koma < 0)
        {
            koma = (-koma) & 0x07;
            mochi[0][koma]++;
        }

		/* Âʒű̎ނ𓾂B */
        if (i_old > UCHI_KOMA)
        {
			koma = i_old - UCHI_KOMA;
			mochi[teban][koma]--;
            if(teban)koma = -koma;
        }
        else
        {
            koma = men_kifu[ix_old][iy_old];
            men_kifu[ix_old][iy_old] = 0;
            if (i_naru == 1)
            {
                if (teban == 0)
                {
                    if (koma > 8)
                    {
                        i_naru = 0;
                    }
                    else
                    {
                        koma += 0x08;
                    }
                }
                else
                {
                    if (koma < -8)
                    {
                        i_naru = 0;
                    }
                    else
                    {
                        koma -= 8;
                    }
                }
            }
        }
        men_kifu[ix_new][iy_new] = koma;
	}

	/*********************/
	/* ǖʂZ[uB*/
	/*********************/
    i_mae = i_new;
    teban = tesu & 0x01;
    if (teban == 0)
    {
        for (ix = 0; ix < 9 ; ix++)
        {
            for (iy = 0 ; iy < 9 ; iy++)
            {
                men_kifu2[ix][iy] = men_kifu[ix][iy];
            }
        }
    }
    else
    {
        for (ix = 0; ix < 9 ; ix++)
        {
            for (iy = 0 ; iy < 9 ; iy++)
            {
                men_kifu2[8 - ix][8 - iy] = -men_kifu[ix][iy];
            }
        }
    }

	/**************************/
	/* ῗB */
	/**************************/
    i_new = kifu[te][0];
    if (i_new == 0)return;

    if (teban)
    {
		strcopy(cmoji,"");
    }
	else
	{
		strcopy(cmoji,"");
    }

    if (i_new > NARU_CODE)
    {
        i_naru = 1;
        i_new -= NARU_CODE;
	}
    else
    {
        i_naru = 0;
    }
    i_new--;
    ix_new = i_new % 9;
    iy_new = i_new / 9;
    strcopy(&cmoji[2],sansuji[ix_new]);
    strcopy(&cmoji[4],kansuji[iy_new]);
    if (i_mae == i_new)
    {
        strcopy(&cmoji[2],"@");
    }
    i_old = kifu[te][1];
    if (i_old < 100)
    {
       i_old--;
       ix_old = i_old % 9;
       iy_old = i_old / 9;
    }

	/* Vʒű */
    koma = men_kifu[ix_new][iy_new];
    if (koma > 0)
    {
        koma &= 0x07;
        mochi[1][koma]++;
    }
    else if (koma < 0)
    {
        koma = (-koma) & 0x07;
        mochi[0][koma]++;
    }

	/* Âʒű̎ނ𓾂B */
    if (i_old > UCHI_KOMA)
    {
        koma = i_old - UCHI_KOMA;
		mochi[teban][koma]--;
        koma_old = koma;
        if(teban)koma = -koma;
    }
    else
    {
        koma = men_kifu[ix_old][iy_old];
        if (koma > 0)
        {
            koma_old = koma;
        }
        else
        {
            koma_old = -koma;
        }
        men_kifu[ix_old][iy_old] = 0;
        if (i_naru)
        {
            if (teban == 0)
            {
                if (koma > 8)
                {
                    i_naru = 0;
                }
                else
                {
                    koma += 0x08;
                }
            }
            else
            {
                if (koma < -8)
                {
                    i_naru = 0;
                }
                else
                {
                    koma -= 8;
                }
            }
        }
    }
	strcat2(cmoji,komamoji[koma_old]);
    men_kifu[ix_new][iy_new] = koma;
    if(teban == 1)
    {
        ix_new = 8 - ix_new;
        iy_new = 8 - iy_new;
        ix_old = 8 - ix_old;
        iy_old = 8 - iy_old;
    }
	if(i_old > UCHI_KOMA)
	{
        ix_old = -1;
        iy_old = koma_old;
    }
    fuki(cmoji,ix_new,iy_new,ix_old,iy_old,i_naru); /* */

	/* Œ蒷WɂB */
    for (i = 0; i < 16 ; i+= 2)
    {
        if(cmoji[i] == 0)
        {
			strcopy(&cmoji[i],"  ");
        }
    }
	strcopy(&cmoji[16],"  ");
}

/*****************************/
/*  ̕tL\쐬B */
/*****************************/
void COkiDoc::fuki(char* moji,int ix_new,int iy_new,int ix_old,int iy_old
			,int i_naru)
{
    int koma;

	/* ړ𔻒fB */
    if (ix_old < 0)
    {
        koma = iy_old;
    }
    else
    {
        koma = men_kifu2[ix_old][iy_old];
    }

	/* ʏ */
    switch(koma)
    {
    case 1:  /*  */
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 2:  /*  */
        kyo(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 3:  /* j */
        kei(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 4:  /*  */
        gin(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 5:  /*  */
    case 9:  /*  */
    case 10: /*  */
    case 11: /* j */
    case 12: /*  */
        kin(moji,ix_new,iy_new,ix_old,iy_old);
        break;
    case 6:  /* p */
        kaku(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 7:  /*  */
        hisya(moji,ix_new,iy_new,ix_old,iy_old);
        naru_k(moji,iy_new,ix_old,iy_old,i_naru);
        break;
    case 14: /* n */
        uma(moji,ix_new,iy_new,ix_old,iy_old);
        break;
    case 15: /*  */
        ryu(moji,ix_new,iy_new,ix_old,iy_old);
        break;
    default:
        break;
    }
}

/******************************/
/* As̕\vZB */
/******************************/
void COkiDoc::naru_k(char* moji,int iy_new,int ix_old,int iy_old,int i_naru)
{
    if (ix_old < 0)return;              /* ł */
    if ((iy_old >= 3) && (iy_new >= 3))return;
    if (i_naru == 1)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"s");
    }
}

/*****************************/
/*  ̕tL\vZB */
/*****************************/
void COkiDoc::kyo(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int iy;

	/* łȊÓAtLsv */
    if (ix_old >= 0)return;

	/* Տō̏ꏊɍs邩H */
    for (iy = iy_new + 1; iy < 9 ; iy++)
    {
        if (men_kifu2[ix_new][iy] == 2)
        {
            strcat2(moji,"");
        }
        if (men_kifu2[ix_new][iy] != 0)break;
    }
}

/*****************************/
/*  j̕tL\vZB */
/*****************************/
void COkiDoc::kei(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int iy;
    int cnt;

/* Q݂邩H */
    iy = iy_new + 2;
    if (iy >= 9)return;

/* ̈ʒuɂj̐𐔂B */
    cnt = 0;
    if (ix_new > 0)
    {
        if (men_kifu2[ix_new - 1][iy] == 3)
        {
            cnt++;
        }
    }
    if (ix_new < 8)
    {
        if (men_kifu2[ix_new + 1][iy] == 3)
        {
            cnt++;
        }
    }

/* ł𒲂ׂB */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

/* QȏAj݂邩H */
    if (cnt < 2)return;

/* EA */
    if (ix_old > ix_new)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"E");
    }
}

/*****************************/
/*  ̕tL\vZB */
/*****************************/
void COkiDoc::gin(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int cnt;
    int flag[3][3];

/* tONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

/* }bv쐬B */
    for (i = 0; i < 3 ; i++)
    {
        ix = ix_new + i - 1;
        if (ix < 0)continue;
        if (ix > 8)continue;
        for (j = 0 ; j < 3 ; j += 2)
        {
            iy = iy_new + j - 1;
            if (iy < 0)continue;
            if (iy > 8)continue;
            if (men_kifu2[ix][iy] == 4)flag[i][j] = 1;
        }
    }
    flag[1][0] = 0;                     /* ͐^ɈȂB */

/* ̈ʒuɍs̐𒲂ׂB */
    cnt = 0;
    for (i = 0 ; i < 3 ; i++)
    {
        for (j = 0 ; j < 3 ; j += 2)
        {
            if (flag[i][j] != 0)cnt++;
        }
    }

/* ł𒲂ׂB */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

/* Qȏ㑶݂Ȃ΁AI */
    if (cnt < 2)return;

/* ʒȕꍇ */
    if (ix_new == ix_old)
    {
        strcat2(moji,"");
        return;
    }

/* Aœoꍇ */
    if (iy_old < iy_new)
    {
        cnt = flag[0][0] + flag[2][0];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else
    {
        cnt = flag[0][2] + flag[1][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
        flag[2][0] = 0;
        flag[2][2] = 0;
    }
    else
    {
        strcat2(moji,"");
        flag[0][0] = 0;
        flag[0][2] = 0;
    }

/* oH */
    cnt = flag[0][0] + flag[0][2] + flag[2][0] + flag[2][2];
    if (cnt <= 1)return;

/* A */
    if (iy_old < iy_new)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"");
    }
}

/*******************************/
/*  ^̕tL\vZB */
/*******************************/
void COkiDoc::kin(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int cnt;
    int koma;
    int flag[3][3];

/* }bvtONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

/* }bv쐬B */
    if (ix_old < 0)
    {
        koma = iy_old;
    }
    else
    {
        koma = men_kifu2[ix_old][iy_old];
    }
    for (i = 0; i < 3 ; i++)
    {
        ix = ix_new + i - 1;
        if (ix < 0)continue;
        if (ix > 8)continue;
        for (j = 0 ; j < 3 ; j++)
        {
            iy = iy_new + j - 1;
            if (iy < 0)continue;
            if (iy > 8)continue;
            if (men_kifu2[ix][iy] == koma)flag[i][j] = 1;
        }
    }
    flag[0][0] = 0;                     /* ͎΂߂ɈȂB */
    flag[2][0] = 0;                     /* ͎΂߂ɈȂB */

/* ̈ʒuɂ̐𒲂ׂB */
    cnt = 0;
    for (i = 0 ; i < 3 ; i++)
    {
        for (j = 0 ; j < 3 ; j++)
        {
            if (flag[i][j] != 0)cnt++;
        }
    }

/* ł𒲂ׂB */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

/* Qȏ㑶݂Ȃ΁AI */
    if (cnt < 2)return;

/* ʒu܂͈̏ꍇ */
    if (ix_new == ix_old)
    {
        if (iy_old < iy_new)
        {
            strcat2(moji,"");
        }
        else
        {
            strcat2(moji,"");
        }
        return;
    }

/* œoꍇ */
    if (iy_old > iy_new)
    {
        cnt = flag[0][2] + flag[1][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

/* œoꍇ */
    if (iy_old == iy_new)
    {
        cnt = flag[0][1] + flag[2][1];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");		/* ʒu}bv ix-> 2 1 0 iy */
        flag[2][1] = 0;			/*                   x o x 0  */
        flag[1][2] = 0;			/*                   o x o 1  */
        flag[2][2] = 0;			/*                   o o o 2  */ 
    }
    else
    {
        strcat2(moji,"");
        flag[0][1] = 0;
        flag[1][2] = 0;
        flag[0][2] = 0;
    }

/* oH */
    cnt = flag[0][1] + flag[0][2] + flag[1][2] + flag[2][1] + flag[2][2];
    if (cnt <= 1)return;

/* A */
    if (iy_old == iy_new)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"");
    }
}

/*****************************/
/*  p̕tL\vZB */
/*****************************/
void COkiDoc::kaku(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int k;
    int cnt;
    int flag[3][3];
    int ix_step;
    int iy_step;

    for (i = 0 ; i < 3 ; i += 2)
    {
        for ( j = 0 ; j < 3 ; j += 2)
        {
            flag[i][j] = 0;
        }
    }

	/* ̈ʒuɂ邩vZB */
    cnt = 0;
    for (i = 0; i < 3 ; i += 2)
    {
        ix_step = i - 1;
        for (j = 0 ; j < 3 ; j += 2)
        {
            iy_step = j - 1;
            ix      = ix_new;
            iy      = iy_new;
            for (k = 0 ; k < 8 ; k++)
            {
                ix += ix_step;
                iy += iy_step;
                if (ix < 0)break;
                if (ix > 8)break;
                if (iy < 0)break;
                if (iy > 8)break;
                if (men_kifu2[ix][iy] != 0)
                {
                    if (men_kifu2[ix][iy] == 6)
                    {
                        flag[i][j] = 1;
                        cnt++;
                    }
                    break;
                }
            }
        }
    }

	/* łꍇ̏ */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

	/* ̈ʒuɂP̏ꍇ */
    if (cnt <= 1)return;

	/* Aœoꍇ */
    if (iy_old < iy_new)
    {
        cnt = flag[0][0] + flag[2][0];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else
    {
        cnt = flag[0][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

	/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
    }
    else
    {
        strcat2(moji,"");
    }
}

/*****************************/
/*  ̕tL\vZB */
/*****************************/
void COkiDoc::hisya(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int k;
    int cnt;
    int flag[3][3];
    int ix_step;
    int iy_step;

	/* }bvtONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

	/* ̈ʒuɂ邩vZB */
    cnt = 0;
    for (i = 0; i < 3 ; i++)
    {
        ix_step = i - 1;
        for (j = 0 ; j < 3 ; j++)
        {
            iy_step = j - 1;
            ix      = ix_new;
            iy      = iy_new;
            if (ix_step == 0)
            {
                if (iy_step == 0)continue;
            }
            else
            {
                if (iy_step != 0)continue;
            }
            for (k = 0 ; k < 8 ; k++)
            {
                ix += ix_step;
                iy += iy_step;
                if (ix < 0)break;
                if (ix > 8)break;
                if (iy < 0)break;
                if (iy > 8)break;
                if (men_kifu2[ix][iy] != 0)
                {
                    if (men_kifu2[ix][iy] == 7)
                    {
                        flag[i][j] = 1;
                        cnt++;
                    }
                    break;
                }
            }
        }
    }

	/* łꍇ̏ */
    if (ix_old < 0)
    {
        if (cnt > 0)
        {
            strcat2(moji,"");
        }
        return;
    }

	/* ̈ʒuɂP̏ꍇ */
    if (cnt <= 1)return;

	/* ̏ꍇ */
    if (iy_old < iy_new)
    {
        strcat2(moji,"");
        return;
    }

	/* ̏ꍇ */
    if (iy_old > iy_new)
    {
        strcat2(moji,"");
        return;
    }

	/* ̏ꍇ */
    if (flag[0][1] != flag[2][1])
    {
        strcat2(moji,"");
        return;
    }

	/* EȀꍇ */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
    }
    else
    {
        strcat2(moji,"");
    }
}

/*****************************/
/*  n̕tL\vZB */
/*****************************/
void COkiDoc::uma(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int k;
    int kmax;
    int cnt;
    int flag[3][3];
    int ix_step;
    int iy_step;

	/* }bvtONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

	/* ̈ʒuɂ邩vZB */
    cnt = 0;
    for (i = 0; i < 3 ; i++)
    {
        ix_step = i - 1;
        for (j = 0 ; j < 3 ; j++)
        {
            iy_step = j - 1;
            ix      = ix_new;
            iy      = iy_new;
            if(ix_step == 0)
            {
                if (iy_step == 0)continue;
                kmax = 1;
            }
            else if (iy_step == 0)
            {
                kmax = 1;
            }
            else
            {
                kmax = 8;
            }
            for (k = 0 ; k < kmax ; k++)
            {
                ix += ix_step;
                iy += iy_step;
                if (ix < 0)break;
                if (ix > 8)break;
                if (iy < 0)break;
                if (iy > 8)break;
                if (men_kifu2[ix][iy] != 0)
                {
                    if (men_kifu2[ix][iy] == 14)
                    {
                        flag[i][j] = 1;
                        cnt++;
                    }
                    break;
                }
            }
        }
    }

	/* ̈ʒuɂP̏ꍇ */
    if (cnt <= 1)return;

	/* AAœoꍇ */
    if (iy_old < iy_new)
    {
        cnt = flag[0][0] + flag[1][0] + flag[2][0];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else if (iy_old == iy_new)
    {
        cnt = flag[0][1] + flag[2][1];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else
    {
        cnt = flag[0][2] + flag[1][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

	/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
    }
    else if (ix_old > ix_new)
    {
        strcat2(moji,"");
    }
    else if (iy_old < iy_new)
    {
        strcat2(moji,"");
    }
    else
    {
        strcat2(moji,"");              /* nnォH */
    }
}

/*****************************/
/*  ̕tL\vZB */
/*****************************/
void COkiDoc::ryu(char* moji,int ix_new,int iy_new,int ix_old,int iy_old)
{
    int ix;
    int iy;
    int i;
    int j;
    int k;
    int kmax;
    int cnt;
    int flag[3][3];
    int ix_step;
    int iy_step;

	/* }bvtONAB */
    for (i = 0 ; i < 3 ; i++)
    {
        for ( j = 0 ; j < 3 ; j++)
        {
            flag[i][j] = 0;
        }
    }

	/* ̈ʒuɂ邩vZB */
    cnt = 0;
    for (i = 0; i < 3 ; i++)
    {
        ix_step = i - 1;
        for (j = 0 ; j < 3 ; j++)
        {
            iy_step = j - 1;
            ix      = ix_new;
            iy      = iy_new;
            if(ix_step == 0)
            {
                if (iy_step == 0)continue;
                kmax = 8;
            }
            else if (iy_step == 0)
            {
                kmax = 8;
            }
            else
            {
                kmax = 1;
            }
            for (k = 0 ; k < kmax ; k++)
            {
                ix += ix_step;
                iy += iy_step;
                if (ix < 0)break;
                if (ix > 8)break;
                if (iy < 0)break;
                if (iy > 8)break;
                if (men_kifu2[ix][iy] != 0)
                {
                    if (men_kifu2[ix][iy] == 15)
                    {
                        flag[i][j] = 1;
                        cnt++;
                    }
                    break;
                }
            }
        }
    }

	/* ̈ʒuɂP̏ꍇ */
    if (cnt <= 1)return;

	/* AAœoꍇ */
    if (iy_old < iy_new)
    {
        cnt = flag[0][0] + flag[1][0] + flag[2][0];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else if (iy_old == iy_new)
    {
        cnt = flag[0][1] + flag[2][1];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }
    else
    {
        cnt = flag[0][2] + flag[1][2] + flag[2][2];
        if (cnt <= 1)
        {
            strcat2(moji,"");
            return;
        }
    }

	/* EA */
    if (ix_old < ix_new)
    {
        strcat2(moji,"E");
    }
    else if (ix_old > ix_new)
    {
        strcat2(moji,"");
    }
    else if (iy_old < iy_new)
    {
        strcat2(moji,"");
    }
    else
    {
        if (iy_old == (iy_new - 1))
        {
            strcat2(moji,"");          /* ォEH */
        }
        else
        {
            strcat2(moji,"");          /* ォEH */
        }
    }
}

/****************************/
/* `؏pR[hϊ */
/****************************/

int COkiDoc::get_koma_code(char *moji,char *k)
{
    int kotae;

    kotae = 0;
    while(*k)
    {
        if (strncmp(moji,k,2) == 0)
        {
            return(kotae);
        }
        kotae++;
        k += 2;
    }
    return(0);
}

/**********************/
/* `؏p䐶 */
/**********************/

void COkiDoc::komadai(char *s,char *mochi)
{
    int     k;
    int     koma;
    int     iend;

    for (koma = 0 ; koma < 8 ; koma++)
    {
        mochi[koma] = 0;
    }

    koma = -1;
    iend = 1;
    while(iend)
    {
        switch (moji_size(*s))
        {
        case 2:
            k = get_koma_code(s,"@jp");
            if (k > 0)
            {
                koma = k;
                mochi[koma]++;
			}
			else
			{
				k = get_koma_code(s,"@OlܘZ\");
				if (k > 0)
				{
					if (mochi[koma] == 10)
                    {
                        mochi[1] += k;
                    }
                    else
                    {
                        mochi[koma] = k;
                    }
                }
            }
            s += 2;
            break;
        case 1:
            s++;
            break;
        default:
            iend = 0;
            break;
        }
    }
}

int COkiDoc::get_kakinoki_shohi(char *moji)
{
    int		hour;
    int		min;
    int		sec;

    sec  = 0;

    if (strlen(moji) < 34)return(sec);
    if (moji[24] != '/')return(sec);
    if (moji[27] != ':')return(sec);
    if (moji[30] != ':')return(sec);
    if (moji[33] != ')')return(sec);
    hour = atoi(&moji[25]);
    min  = atoi(&moji[28]);
    sec  = atoi(&moji[31]);
    return(hour * 3600 + min * 60 + sec);
}

void COkiDoc::OnFileClipIn()
{
	int		i;
	int		j;
	int		k;
	int		v;
	int		te;
	int		ix;
	int		iy;
	int		teki;
	int		ip;
	int		iprog;
	int		type;
	int		iexit;
	int		koma;
	int		maisu;
	int		naru;
	int		len;
	int		old;
	int		newx;
	int		mochi_flag;
	int		men_i[10][10];
	int		mochi[2][8];
	char	*m;
	char	*y;
	char	*s;
	char	*kmoji;
	char	ssman[28];
	char	ggman[28];
	char	men[100];
	char	moji[256];

	if (clip_open())
	{
		type = 0;
		while(clip_gets(moji,sizeof(moji)))
		{
			if (strncmp(moji,"",4) == 0)
			{
				type = 1;
			}
			else if (strncmp(moji,"",4) == 0)
			{
				type = 1;
			}
			else if (strncmp(moji,"",2) == 0)
			{
				type = 1;
			}
			else if (strncmp(moji,"",2) == 0)
			{
				type = 1;
			}
			else 
			{
				switch(moji[0])
				{
				case '#':
					type = 1;
					break;
				case 'N':
				case 'P':
				case '+':
				case '-':
					type = 2;
					break;
				default:
					break;
				}
			}
			if (type)break;
		}
		if (type == 0)type = 1;
		clip_offset(0);
		iexit = 0;
		memset(men,0,100);
		ssman[0] = ggman[0] = 0;
		switch(type)
		{
		case 1:
			iprog = -1;
			while(clip_gets(moji,sizeof(moji)))
			{
				if (iprog < 0)
				{
					if (moji[0] == '#')
					{
						iprog = 13;
					}
					else
					{
						iprog = 0;
					}
				}
				switch(iprog)
				{
				case 0:
					if (strncmp(moji,"F",6) == 0)
						{
						get_moji(ssman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"F",6) == 0)
					{
						get_moji(ggman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"F",6) == 0)
					{
						get_moji(ssman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"F",6) == 0)
					{
						get_moji(ggman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"tF",6) == 0)
					{
						tab_cut (&moji[6]);
						get_date(&moji[6]);
						break;
					}
					else if (strncmp(moji,"ԁF",6) == 0)
					{
						if (strncmp(&moji[6],"",6) == 0)
						{
							tesu = teban_flag = 0;
						}
						else if (strncmp(&moji[6],"",6) == 0)
						{
							tesu = teban_flag = 1;
						}
						else if (strncmp(&moji[6],"",6) == 0)
						{
							tesu = teban_flag = 1;
						}
						else if (strncmp(&moji[6],"",6) == 0)
						{
							tesu = teban_flag = 0;
						}
						break;
					}
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:
				case 7:
				case 8:
					if (moji[0] == '|')	// `،`
					{
						iprog++;
						ip = iprog * 9;
						m  = moji + 1;
						for (i = 0 ; i < 9 ; i++)
						{
							switch(*m++)
							{
							case 'v':
							case 'V':
								teki = 1;
								break;
							default:
								teki = 0;
								break;
							}
	
							kmoji = kakinoki_koma;
							for (koma = 0 ; koma < 16; koma++)
							{
								if (strncmp(m,kmoji,2) == 0)break;
								kmoji += 2;
							}
							if (koma >= 16)
							{
								if (strncmp(m,"",2) == 0)
								{
									koma = SRYU;
								}
								else if (strncmp(m,"",2) == 0)
								{
									koma = SOU;
								}
								else
								{
									koma = 0;
								}
							}

							if (koma == SOU)
							{
								if (teki)
								{
									PGOU = ip;
								}
								else
								{
									PSOU = ip;
								}
							}
							if (teki)koma = -koma;
							men[ip--] = koma;
							m += 2;
						}
           			}
					break;
				case 9:
			        if ((strncmp(moji,"莝F",10) == 0) || 
				    	(strncmp(moji,"莝F",10) == 0)	)
					{
						iprog++;
						m = moji + 10;
						while(*m)
						{
							kmoji = kakinoki_koma + 2;
							koma  = 0;
							for (i = 1 ; i < 8 ; i++)
							{
								if (strncmp(m,kmoji,2) == 0)
								{
									koma = i;
									m += 2;
									if (strncmp(m,"\",2) == 0)
									{
										maisu = 10;
										m += 2;
									}
									else
									{
										maisu = 1;
									}
									y = ymoji;
									for (j = 1 ; j < 10 ; j++)
									{
										if (strncmp(m,y,2) == 0)
										{
											if (maisu > 9)
											{
												maisu += j;
											}
											else
											{
												maisu = j;
											}
											m += 2;
											break;
										}
										y += 2;
									}
									break;
								}
								kmoji += 2;
							}
							if (koma)
							{
								men[koma + 82] = maisu;
							}
							else
							{
								break;
							}
						}
					}
					break;
				case 10:
					if ((strncmp(moji,"莝F",10) == 0)	||
						(strncmp(moji,"莝F",10) == 0) )
					{
						iprog++;
						m = moji + 10;
						while(*m)
						{
							kmoji = kakinoki_koma + 2;
							koma  = 0;
							for (i = 1 ; i < 8 ; i++)
							{
								if (strncmp(m,kmoji,2) == 0)
								{
									koma = i;
									m += 2;
									if (strncmp(m,"\",2) == 0)
									{
										maisu = 10;
										m += 2;
									}
									else
									{
										maisu = 1;
									}
									y = ymoji;
									for (j = 1 ; j < 10 ; j++)
									{
										if (strncmp(m,y,2) == 0)
										{
											if (maisu > 9)
											{
												maisu += j;
											}
											else
											{
												maisu = j;
											}
											m += 2;
											break;
										}
										y += 2;
									}
									break;
								}
								kmoji += 2;
							}
							if (koma)
							{
								men[koma + 90] = maisu;
							}
							else
							{
								break;
							}
						}
						memcpy(initial_kyokumen,men,100);
						memcpy(men_h,men,100);
						te = teban_flag;
						kifu[te][0] = 0;
						sman2[0] = gman2[0] = 0;
						strcopy(sman,ssman);
						strcopy(gman,ggman);
						timer_sec[0] = timer_sec[1] = 0;
						i = 1;
						for (iy = 1;iy < 10 ; iy++)
						{
							for (ix = 1; ix < 10;ix++)
							{
								j = men[i++];
								if (j < 0)
								{
									j = -j + 16;
								}
								men_i[ix][iy] = j;
							}
						}
						for (j = 0; j < 8 ; j++)
						{
							mochi[0][j] = men[i++];
						}
						for (j = 0; j < 8 ; j++)
						{
							mochi[0][j] = men[i++];
						}
					}
					break;
				case 11:	// Xc
		           if (strncmp(moji,"MAKE",4) == 0)
					{
						if ((te & 0x01) == 0)
						{
							end_code = 2;
						}
						else
						{
							end_code = 1;
						}
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"BREAK",5) == 0)
					{
						end_code = 0;
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"KINTE",5) == 0)
					{
						if ((te & 0x01) == 0)
						{
							end_code = 1;
						}
						else
						{
							end_code = 2;
						}
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"SENNITITE",9) == 0)
					{
						end_code = 3;
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"JISHOUGI",8) == 0)
					{
						end_code = 4;
						iprog++;
						iexit = 1;
					}
					else if (tesu >= 3000)
					{
						end_code = 0;
						iprog++;
						iexit = 1;
					}
					else if (strncmp(moji,"",2) == 0)
					{
						kmove(0,&moji[2],men_i,mochi);
						touroku(te);
						shohi[te] = get_shohi(moji);
						te++;
					}
					else if (strncmp(moji,"",2) == 0)
					{
						kmove(1,&moji[2],men_i,mochi);
						touroku(te);
						shohi[te] = get_shohi(moji);
						te++;
					}
					break;
				case 12:
					break;
				case 13:	// `،`
					if (strncmp(moji,"JnF",10) == 0)
					{
						get_date(&moji[10]);
						iprog++;
						break;
					}
				case 14:
					if (strncmp(moji,"荇F",8) == 0)
					{
						for (i = 0 ; i < 9 ; i++)
						{
							if(strncmp(&moji[8],teai_moji[i],teai_len[i]) == 0)
							{
								switch (i)
								{
								case 0:         /*  */
									memcpy(men,hkyokumen,100);
									tesu = teban_flag = 0;
									iprog = 26;
									break;
								case 1:         /*  */
									memcpy(men,hkyokumen,100);
									K11 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 2:         /* p */
									memcpy(men,hkyokumen,100);
									K22 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 3:         /* ԗ */
									memcpy(men,hkyokumen,100);
									K82 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 4:         /* 򍁗 */
									memcpy(men,hkyokumen,100);
									K82 = K11 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 5:         /* 񖇗 */
									memcpy(men,hkyokumen,100);
									K82 = K22 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 6:         /* l */
									memcpy(men,hkyokumen,100);
									K11 = K91 = K22 = K82 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								case 7:         /* Z */
									memcpy(men,hkyokumen,100);
									K11 = K21 = K81 = K91 = K22 = K82 = 0;
									tesu = teban_flag = 1;
									iprog = 26;
									break;
								default:
									tesu = teban_flag = 0;
									iprog = 15;
									break;
								}
								break;
							}
						}
					}
					break;
				case 15:
					if (strncmp(moji,"̎F",12) == 0)
					{
						komadai(&moji[12],&men[90]);
						iprog++;
						break;
					}
					else if (moji[0] == '|')
					{
						iprog++;
					}
				case 16:
				case 17:
				case 18:
				case 19:
				case 20:
				case 21:
				case 22:
				case 23:
				case 24:
					if (moji[0] != '|')
					{
						break;
					}
					j = (iprog - 15) * 9;
					s = moji + 1;
					for (i = 0 ; i < 9 ; i++)
					{
						koma = get_koma_code(&s[1]
									,"Ejpʂƈǌ\Sn");
						if (koma == 16)koma = 15;
						switch(*s)
						{
						case 'v':
						case 'V':
							if (koma == 8)PGOU = j;
							men[j--] = -koma;
							break;
						default:
							if (koma == 8)PSOU = j;
							men[j--] = koma;
							break;
						}
						s += 3;
					}
					iprog++;
					break;
				case 25:
					if (strncmp(moji,"̎F",12) == 0)
					{
						komadai(&moji[12],&men[82]);
						iprog++;
					}
					break;
				case 26:
					if (strncmp(moji,"̎F",12) == 0)
					{
						komadai(&moji[12],&men[90]);
						iprog++;
						break;
					}
					if (strncmp(moji,"",6) == 0)
					{
						tesu = teban_flag = 1;
						break;
					}
					else if(strncmp(moji,"F",6) == 0)
					{
						get_moji(ssman,&moji[6],20);
						break;
					}
					else if(strncmp(moji,"F",6) == 0)
					{
						get_moji(ssman,&moji[6],20);
						break;
					}
					else if(strncmp(moji,"F",6) == 0)
					{
						get_moji(ggman,&moji[6],20);
						break;
					}
					else if(strncmp(moji,"F",6) == 0)
					{
						get_moji(ggman,&moji[6],20);
						break;
					}
					else if (strncmp(moji,"萔-",5) == 0)
					{
						te = teban_flag;
						kifu[te][0] = 0;
						ix_old = iy_old = 0;
						end_code = 0;
						memcpy(initial_kyokumen,men,100);
						memcpy(men_h,men,100);
						sman2[0] = gman2[0] = 0;
						strcopy(sman,ssman);
						strcopy(gman,ggman);
						iprog++;
					}
					break;
				case 27:
					len = strlen(moji);
					if (len < 6)break;
					s = moji + 5;
					if (strncmp(s,"",4) == 0)
					{
						if (te & 0x01)
						{
							end_code = 1;
						}
						else
						{
							end_code = 2;
						}
						iprog++;
						iexit = 1;
						break;
					}
					else if (strncmp(s,"l",2) == 0)
					{
						if (te & 0x01)
						{
							end_code = 1;
						}
						else
						{
							end_code = 2;
						}
						iprog++;
						iexit = 1;
						break;
					}
					else if (strncmp(s,"f",4) == 0)
					{
						end_code = 0;
						iprog++;
						iexit = 1;
						break;
					}
					else if (strncmp(s,"",6) == 0)
					{
						end_code = 3;
						iprog++;
						iexit = 1;
						break;
					}
					else if (strncmp(s,"",6) == 0)
					{
						end_code = 4;
						iprog++;
						iexit = 1;
						break;
					}

					/**************/
					/* VWϊ */
					/**************/

					if (strncmp(s,"",2) == 0)
					{
						ix_new = ix_old;
						iy_new = iy_old;
					}
					else
					{
						ix_new = get_koma_code(s,"@PQRSTUVWX");
						if (ix_new == 0)
						{
							iprog++;
							break;
						}
						iy_new = get_koma_code(&s[2],"@OlܘZ");
						if (iy_new == 0)
						{
							iprog++;
							break;
						}
					}

					/**************/
					/* Wϊ */
					/**************/

					if (strncmp(&s[6],"",2) == 0)
					{
						naru   = 0;
						iy_old = 1;
						ix_old = get_koma_code(&s[4],"@jp") + UCHI_KOMA;
						if (ix_old == UCHI_KOMA)
						{
							iprog++;
							break;
						}
					}
					else if (strncmp(&s[6],"",2) == 0)
					{
						naru   = NARU_CODE;
						ix_old = get_koma_code(&s[8],"@(1(2(3(4(5(6(7(8(9");
						if (ix_old == 0)
						{
							iprog++;
							break;
						}
						iy_old = get_koma_code(&s[10],"@1)2)3)4)5)6)7)8)9)");
						if (iy_old == 0)
						{
							iprog++;
							break;
						}
					}
					else if (strncmp(&s[4],"",2) == 0)
					{
						naru   = 0;
						ix_old = get_koma_code(&s[8],"@(1(2(3(4(5(6(7(8(9");
						if (ix_old == 0)
						{
							iprog++;
							break;
						}
						iy_old = get_koma_code(&s[10],"@1)2)3)4)5)6)7)8)9)");
						if (iy_old == 0)
						{
							iprog++;
							break;
						}
					}
					else
					{
						naru = 0;
						ix_old = get_koma_code(&s[6],"@(1(2(3(4(5(6(7(8(9");
						if (ix_old == 0)
						{
							iprog++;
							break;
						}
						iy_old = get_koma_code(&s[8],"@1)2)3)4)5)6)7)8)9)");
						if (iy_old == 0)
						{
							iprog++;
							break;
						}
					}

					/******************/
					/* f[^o^ */
					/******************/
					kifu[te + 1][0] = 0;
					kifu[te][0] = iy_new * 9 + ix_new - 9 + naru;
					kifu[te][1] = iy_old * 9 + ix_old - 9;
					shohi[te] = get_kakinoki_shohi(moji);
					ix_old = ix_new;
					iy_old = iy_new;
					te++;
					if (te >= 3000)
					{
						iexit = 1;
						break;
					}
					break;
       			default:
					break;
				}
				if (iexit)break;
			}
			if (iprog < 13)
			{
				::PostMessage(m_hWnd,WM_FILE,te,1);
			}
			else
			{
				::PostMessage(m_hWnd,WM_FILE,te,3);
			}
			break;
		case 2:
			iprog = 0;
			while(clip_gets(moji,sizeof(moji)))
			{
				switch(iprog)
				{
				case 1:
					if (moji[0] == 'N')
					{
						if (moji[1] == '-')
						{
							get_moji_unix(ggman,&moji[2],20);
							mchange(ggman);
							iprog++;
						}
					}
					break;
				case 0:
					if (moji[0] == 'N')
					{
						if (moji[1] == '+')
						{
							get_moji_unix(ssman,&moji[2],20);
							mchange(ssman);
							iprog++;
							break;
						}
					}
				case 2:
					if (moji[1] == 'I')break;
				case 3:
				case 4:
				case 5:
				case 6:
				case 7:
				case 8:
				case 9:
				case 10:
				case 11:
					if (moji[0] == 'P')
					{
						if (iprog <= 2)
						{
							iprog = 3;
						}
						else
						{
							if (moji[1] == '+')break;
							if (moji[1] == '-')break;
							iprog++;
						}
						s = moji + 2;
						ip = (iprog - 2) * 9;
						for (i = 0 ; i < 9 ; i++)
						{
							switch(*s++)
							{
							case '+':
								men[ip--] = csa_koma_code(s);
								s += 2;
								break;
							case '-':
								men[ip--] = -csa_koma_code(s);
								s += 2;
								break;
							case '*':
								men[ip--] = 0;
								if (*s == '*')
								{
									s += 2;
								}
								else
								{
									s++;
								}
								break;
							default:
								men[ip--] = 0;
								s += 2;
								break;
							}
						}
						break;
					}
				case 12:	// ????
				case 13:
					switch(moji[0])
					{
					case '+':
					case '-':
						if (iprog <= 2)
						{
							memcpy(men,hkyokumen,100);
						}
						else
						{
							for (i = 1 ; i <= 81 ;i++)
							{
								switch(men[i])
								{
								case SOU:
									PSOU = i;
									break;
								case GOU:
									PGOU = i;
									break;
								default:
									break;
								}
							}
						}
						if (moji[0] == '+')
						{
							tesu = teban_flag = 0;
						}
						else
						{
							tesu = teban_flag = 1;
						}
						iprog = 14;
					}
					mochi_flag = 0;
					kifu[tesu][0] = 0;
					end_code = 0;
					memcpy(initial_kyokumen,men,100);
					memcpy(men_h,men,100);
					te = teban_flag;
					sman2[0] = gman2[0] = 0;
					strcopy(sman,ssman);
					strcopy(gman,ggman);
					timer_sec[0] = timer_sec[1] = 0;
					if (moji[1] == 0)break;
				case 14:                        /* w */
					switch (moji[0])
					{
					case '%':
						if (mochi_flag)
						{
							te++;
						}
						kifu[te][0] = 0;
						if (moji[1] == 'T')
						{
							if (te & 0x0001)
							{
								end_code = 1;
							}
							else
							{
								end_code = 2;
							}
						}
						else
						{
							end_code = 0;
						}
						iexit = 1;
						break;
					case 'T':			// 
						if (mochi_flag)
						{
							mochi_flag = 0;
							v = atoi(&moji[1]);
							shohi[te] += v;
							te++;
						}
						break;
					case '+':
						if (te >= 3000)
						{
							end_code = 0;
							iexit    = 1;
							break;
						}
						if (te & 0x0001)
						{
							te++;
						}
						kifu[te + 1][0] = 0;
						if (moji[1] == '0')		// ŋ
						{
							if (moji[2] == '0')
							{
								k = csa_koma_code(&moji[5]);
							}
							else
							{
								k = csa_koma_code(&moji[4]);	// W΍
							}
							v = atoi(&moji[2]);
							kifu[te][1] = UCHI_KOMA + k;
							ix = v / 10;
							iy = v % 10;
							ip = (iy - 1) * 9 + ix;
							kifu[te][0] = ip;
						}
						else
						{
							k = csa_koma_code(&moji[5]);
							v = atoi(&moji[1]);
							old  = v / 100;
		        			newx = v % 100;
							ix = old / 10;
							iy = old % 10;
							i = (iy - 1) * 9 + ix;
							kifu[te][1] = (iy - 1) * 9 + ix;
							ix = newx / 10;
							iy = newx % 10;
							ip = (iy - 1) * 9 + ix;
							kifu[te][0] = ip;
							if (men[i] != k)
							{
								kifu[te][0] += NARU_CODE;
							}
							men[i] = 0;
						}
						men[ip] = k;
						if ((te - 2) >= teban_flag)
						{
							shohi[te] = shohi[te - 2];
						}
						else
						{
							shohi[te] = 0;
						}
						mochi_flag = 1;
						if (moji[7] == ',')
						{
							if (moji[8] == 'T')
							{
								mochi_flag = 0;
								v = atoi(&moji[9]);
								shohi[te] += v;
								te++;
							}
						}
						break;
					case '-':
						if (te >= 3000)
						{
							end_code = 0;
							iexit    = 1;
							break;
						}
						if ((te & 0x0001) == 0)
						{
							te++;
						}
						kifu[te + 1][0] = 0;
						if (moji[1] == '0')		// ŋ
						{
							if (moji[2] == '0')
							{
								k = csa_koma_code(&moji[5]);
							}
							else
							{
								k = csa_koma_code(&moji[4]);	// W΍
							}
							v = atoi(&moji[2]);
							kifu[te][1] = UCHI_KOMA + k;
							ix = v / 10;
							iy = v % 10;
							ip = (iy - 1) * 9 + ix;
							kifu[te][0] = ip;
							k = -k;
						}
						else
						{
							k = -csa_koma_code(&moji[5]);
							v = atoi(&moji[1]);
							old  = v / 100;
							newx = v % 100;
							ix  = old / 10;
							iy  = old % 10;
							i  = (iy - 1) * 9 + ix;
							kifu[te][1] = (iy - 1) * 9 + ix;
							ix  = newx / 10;
							iy  = newx % 10;
							ip = (iy - 1) * 9 + ix;
							kifu[te][0] = ip;
							if (men[i] != k)
							{
								kifu[te][0] += NARU_CODE;
							}
							men[i] = 0;
						}
						men[ip] = k;
						if ((te - 2) >= teban_flag)
						{
							shohi[te] = shohi[te - 2];
						}
						else
						{
							shohi[te] = 0;
						}
						mochi_flag = 1;
						if (moji[7] == ',')
						{
							if (moji[8] == 'T')
							{
								mochi_flag = 0;
								v = atoi(&moji[9]);
								shohi[te] += v;
								te++;
							}
						}
						break;
					}
					break;
				default:
					break;
				}
				if (iexit)break;
			}
			if (iprog == 14)
			{
				::PostMessage(m_hWnd,WM_FILE,te,2);
			}
			break;
		default:
			break;
		}
		clip_close();
	}
}

void COkiDoc::OnUpdateFileClipIn(CCmdUI *pCmdUI)
{
	if (job_no)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}
}
