/************************/
/*    TaikyokuDlg.cpp   */
/************************/
#include "stdafx.h"
#include "Oki.h"
#include "TaikyokuDlg.h"
#include <math.h>

/////////////////////////////////////////////////////////////////////////////
// CTaikyokuDlg _CAO

extern int	teban_flag;
extern int	lan_prog;
extern int	you_teban;
extern char	Current_Dir[];
extern char	hkyokumen[];
extern char	initial_kyokumen[];

static char	*man_moji[] = { "Ȃ" ,
							"B1","B2","B3",
							"B4","B5","B6",
							"B7","B8","B9",
							"DLL",
							"RS232C","LAN" };

IMPLEMENT_DYNAMIC(CTaikyokuDlg,CDialog)

CTaikyokuDlg::CTaikyokuDlg(int m,CWnd* pParent /*=NULL*/)
	: CDialog(CTaikyokuDlg::IDD, pParent)
{
	m_sman     = _T("");
	m_gman     = _T("");
	m_sman2    = _T("");
	m_gman2    = _T("");
	m_hanten   = FALSE;
	m_kyokumen = 0;
	m_kisen    = _T("");
	m_senkei   = _T("");
	m_kyoku    = _T("");
	m_nen      = 2006;
	m_tsuki    = 5;
	m_hi       = 4;
	m_ji       = _T("");
	m_fun      = _T("");
	m_byo      = _T("");

	mode       = m;
	m_nkyoku   = 0;
	m_mochi    = 1500;
	m_sec      = 0;
}

void CTaikyokuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_CBString(pDX, IDC_CMB_SENTE, m_sman);
	DDX_CBString(pDX, IDC_CMB_GOTE, m_gman);
	DDX_Text(pDX, IDC_EDIT_SMAN2, m_sman2);
	DDV_MaxChars(pDX, m_sman2, 12);
	DDX_Text(pDX, IDC_EDIT_GMAN2, m_gman2);
	DDV_MaxChars(pDX, m_gman2, 12);
	DDX_Check(pDX, IDC_CHK_HANTEN, m_hanten);
	DDX_CBIndex(pDX, IDC_CMB_KYOKUMEN, m_kyokumen);
	DDX_CBString(pDX, IDC_CMB_KISEN, m_kisen);
	DDV_MaxChars(pDX, m_kisen, 27);
	DDX_CBString(pDX, IDC_CMB_SENKEI, m_senkei);
	DDV_MaxChars(pDX, m_senkei, 27);
	DDX_Text(pDX, IDC_EDIT_KYOKU, m_kyoku);
	DDX_Text(pDX, IDC_EDIT_NEN, m_nen);
	DDX_Text(pDX, IDC_EDIT_TSUKI, m_tsuki);
	DDX_Text(pDX, IDC_EDIT_HI, m_hi);
	DDX_Text(pDX, IDC_EDIT_JI, m_ji);
	DDX_Text(pDX, IDC_EDIT_FUN, m_fun);
	DDX_Text(pDX, IDC_EDIT_BYO, m_byo);
}

BEGIN_MESSAGE_MAP(CTaikyokuDlg, CDialog)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTaikyokuDlg bZ[W nh

BOOL CTaikyokuDlg::OnInitDialog() 
{
	int			i;
	char		filename[_MAX_PATH];
	char		moji[80];
	FILE		*fp;
	CComboBox	*pSente;
	CComboBox	*pGote;
	CComboBox	*pKisen;
	CComboBox	*pSenkei;

	CDialog::OnInitDialog();
	
	pSente  = (CComboBox*)GetDlgItem(IDC_CMB_SENTE);
	pGote   = (CComboBox*)GetDlgItem(IDC_CMB_GOTE);
	pKisen  = (CComboBox*)GetDlgItem(IDC_CMB_KISEN);
	pSenkei = (CComboBox*)GetDlgItem(IDC_CMB_SENKEI);

	if (mode)
	{
		for (i = 0; i < 13 ; i++)
		{
			pSente->InsertString(-1,man_moji[i]);
			pGote->InsertString (-1,man_moji[i]);
		}
	}
	else
	{
		sprintf_s(filename,"%s\\m.DAT",Current_Dir);
		fopen_s(&fp,filename,"r");
		if (fp)
		{
			while(fgets(moji,sizeof(moji),fp))
    		{
        		if (last_space_cut(moji) > 0)
				{
					pSente->InsertString(-1,moji);
					pGote->InsertString(-1,moji);
				}
			}
			fclose(fp);
		}
	}

	sprintf_s(filename,"%s\\.DAT",Current_Dir);
	fopen_s(&fp,filename,"r");
	if (fp)
	{
		i = 0;
		while(fgets(moji,sizeof(moji),fp))
    	{
			if (moji[0] == '+')continue;
	       	if (last_space_cut(&moji[3]) > 0)
			{
				pKisen->InsertString(-1,&moji[3]);
			}
		}
		fclose(fp);
    }

	sprintf_s(filename,"%s\\^.DAT",Current_Dir);
	fopen_s(&fp,filename,"r");
	if (fp)
	{
		while(fgets(moji,sizeof(moji),fp))
     	{
        	if (last_space_cut(&moji[4]) > 0)
			{
				pSenkei->InsertString(-1,&moji[4]);
			}
		}
		fclose(fp);
    }

	if (m_nkyoku > 0)
	{
		if (m_nkyoku < 10)
		{
			sprintf_s(moji,"%d",m_nkyoku);
		}
		else
		{
			moji[0] = 0;
		}
	}
	else
	{
		moji[0] = 0;
	}
	m_kyoku = moji;

	if (m_mochi >= 3600)
	{
		sprintf_s(moji,"%d",m_mochi / 3600);
	}
	else
	{
		moji[0] = 0;
	}
	m_ji = moji;
	if (m_mochi)
	{
		i = m_mochi / 60;
		sprintf_s(moji,"%d",i % 60); 
	}
	else
	{
		moji[0] = 0;
	}
	m_fun = moji;

	if (m_sec)
	{
		sprintf_s(moji,"%d",m_sec); 
	}
	else
	{
		moji[0] = 0;
	}
	m_byo = moji;

	UpdateData(FALSE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CTaikyokuDlg::OnOK() 
{
	int		i;

	if (!UpdateData(TRUE))return;

	i_man[0] = i_man[1] = 0;
	for ( i = 0 ; i < 13 ; i++)
	{
		if (strcmp(m_sman,man_moji[i]) == 0)
		{
			i_man[0] = i;
			break;
		}
	}
	for ( i = 0 ; i < 13 ; i++)
	{
		if (strcmp(m_gman ,man_moji[i]) == 0)
		{
			i_man[1] = i;
			break;
		}
	}
	if (i_man[0] > 10)i_man[0] = 10 - i_man[0];
	if (i_man[1] > 10)i_man[1] = 10 - i_man[1];

	/* ƂʐM̏ꍇ */
	if (i_man[0] == -2)
	{
		if (i_man[1] == -2)
		{
			MessageBox("ƂLAN̓T|[gĂ܂B","΋");
			return;
		}
	}
	else if (i_man[0] == -1)
	{
		if (i_man[1] == -1)
		{
			MessageBox("ƂRS232C̓T|[gĂ܂B","΋");
			return;
		}
	}

	/***********/
	/* CSA DLL */
	/***********/

	if ((i_man[0] == 10) || (i_man[1] == 10))
	{
		switch(m_kyokumen)
		{
		case 0:
			if (teban_flag)
			{
				i = 1;
			}
			else if (memcmp(initial_kyokumen,hkyokumen,100))
			{
				i = 1;
			}
			else
			{
				i = 0;
			}
			break;
		case 1:
			i = 0;
			break;
		default:
			i = 1;
			break;
		}
		if (i)
		{
			MessageBox("DLĹA΋ǂ݂̂łB","΋");
			return;
		}
	}

	m_nkyoku = atoi(m_kyoku);

	m_mochi  = (atoi(m_ji) * 60 + atoi(m_fun)) * 60;

	m_sec    = atoi(m_byo);

	/***********/
	/* LANڑ */
	/***********/

	if (i_man[0] == -2)
	{
		switch(lan_prog)
		{
		case 0:
		case 1:
			MessageBox("OCKvłB","LAN");
			break;
		case 2:
			MessageBox("΋Ǐ͂Ă܂B","LAN");
			break;
		case 3:
			if (you_teban)
			{
				EndDialog(IDOK);				}
			else
			{
				MessageBox("ԂłB","LAN");
			}
			break;
		case 4:
			MessageBox("΋ǊJn͂Ă܂","LAN");
			break;
		case 5:
			MessageBox("΋ǒłB","LAN");
			break;
		default:
			break;
		}
	}
	else if (i_man[1] == -2)
	{
		switch(lan_prog)
		{
		case 0:
		case 1:
			MessageBox("OCKvłB","LAN");
			break;
		case 2:
			MessageBox("΋Ǐ͂Ă܂B","LAN");
			break;
		case 3:
			if (you_teban)
			{
				MessageBox("ԂłB","LAN");
			}
			else
			{
				EndDialog(IDOK);
			}
			break;
		case 4:
			MessageBox("΋ǊJn͂Ă܂B","LAN");
			break;
		case 5:
			MessageBox("΋ǒłB","LAN");
			break;
		default:
			break;
		}
	}
	else
	{
		EndDialog(IDOK);
	}
}

/********************************/
/* Ō̃Xy[XJbgB */
/********************************/
int CTaikyokuDlg::last_space_cut(char* s)
{
    int     i;
    int     llen;

    i = llen = 0;

    while(s[i])
    {
        if(s[i] == ' ')
        {
            i++;
        }
        else if(s[i] == '\n')
        {
            break;
        }
        else if (strncmp(&s[i],"@",2) == 0)
        {
            i += 2;
        }
        else if (moji_size((unsigned char)s[i]) == 2)
        {
            i   += 2;
            llen = i;
        }
        else
        {
            i++;
            llen = i;
        }

    }
    s[llen] = 0;
    return(llen);
}

int CTaikyokuDlg::moji_size(char c1)
{
	unsigned char	c;

	c = (unsigned char)c1;
    if (c < 0x0020)return(0);
    if (c < 0x007f)return(1);
    if (c < 0x0081)return(0);
    if (c < 0x00a0)return(2);
    if (c < 0x00a1)return(0);
    if (c < 0x00e0)return(1);
    if (c < 0x00fd)return(2);
    return(0);
}
